package com.muzhi.tb.controller;

import com.muzhi.tb.service.TbService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @Author ZhangKan
 * @Data 15:03
 */

@Api(description = "TB接口")
@RestController
@RequestMapping("/tbservice")
public class TbController {

    @Autowired
    private TbService tbService;

    //获取TB中的企业成员列表（TB应用）
    @ApiOperation(value = "获取TB中的企业成员列表（TB应用）")
    @GetMapping("getUserList")
    public String getUserList(){

        String userList = tbService.getUserList();
        return userList;
    }

    @PostMapping("userGet")
    public String userGet(String userId){

        String s = tbService.userGet(userId);
        return s;
    }

    //根据模板创建TB项目
    @PostMapping("createProject")
    public String createProject(String userId,String xiangmuchengyuanList,String xiangmujingli,String chanpinfenlei,
                                String yewuguishu,String quyu,String shishizhuti,String hetongguishu,
                                String xiaoshouleixing,String hetongbianhao,String yewuleixing,String xiangmuleixing,
                                String xiangmudengji,
                                String xiangmumingcheng,String kehuleixing,String kehumingcheng,String kehudengji,String chanpinxian,
                                String suoshusheng,String suoshushiqu,String suoshuquxian,String xiaoshourenyuanList,
                                String shouqianrenyuanList,String hetongjine,String hetongwaijine,String waibujiediaofeiyong,
                                String shifouweidailixiangmu,String qudaodailimingcheng,String yunweimoshi,String yunweiyueshu,
                                String shifouxinyetai,String startDate,String stopDate,String yunweifuzeren,
                                String wanchengriqi,
                                String DJLX,
                                String shifouyutouru,
                                String hetongtuijinzhuangtai,
                                String zhibaoyueshu,
                                String kaipiaojine,
                                String huikuanjine,
                                String kaipiaobili,
                                String huikuanbili){

        String project = tbService.createProject(userId,xiangmuchengyuanList,xiangmujingli,chanpinfenlei,
                yewuguishu,quyu,shishizhuti,hetongguishu,
                xiaoshouleixing,hetongbianhao,yewuleixing,xiangmuleixing,
                xiangmudengji,
                xiangmumingcheng,kehuleixing,kehumingcheng,kehudengji,chanpinxian,
                suoshusheng,suoshushiqu,suoshuquxian,xiaoshourenyuanList,
                shouqianrenyuanList,hetongjine,hetongwaijine,waibujiediaofeiyong,
                shifouweidailixiangmu,qudaodailimingcheng,yunweimoshi,yunweiyueshu,
                shifouxinyetai,startDate,stopDate,yunweifuzeren,
                wanchengriqi,DJLX,shifouyutouru,hetongtuijinzhuangtai,zhibaoyueshu,kaipiaojine,huikuanjine,kaipiaobili,huikuanbili);
        return project;
    }
}
