package com.muzhi.tb.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkproject_1_0.models.AddProjectMemberResponse;
import com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateResponse;
import com.aliyun.dingtalkproject_1_0.models.GetTbUserIdByStaffIdResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.auth0.jwt.JWT;
import com.auth0.jwt.algorithms.Algorithm;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiGettokenRequest;
import com.dingtalk.api.request.OapiRoleSimplelistRequest;
import com.dingtalk.api.request.OapiV2UserGetRequest;
import com.dingtalk.api.request.OapiV2UserGetbymobileRequest;
import com.dingtalk.api.response.OapiGettokenResponse;
import com.dingtalk.api.response.OapiRoleSimplelistResponse;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.dingtalk.api.response.OapiV2UserGetbymobileResponse;
import com.muzhi.tb.service.AccessTokenService;
import com.muzhi.tb.service.TbService;
import com.muzhi.tb.service.YiDaService;
import com.taobao.api.ApiException;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;


@Service
@Slf4j
public class TbServiceImpl implements TbService{

    @Autowired
    private AccessTokenService accessTokenService;

    @Autowired
    private YiDaService yiDaService;

    //闻政tbOrganizationId
    public static String tbOrganizationId = "61dd45c6a1b6504502b29f8c";

    public static String body = null;
    public static String result = null;


    /*钉钉-TB接口*/
    public static com.aliyun.dingtalkproject_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkproject_1_0.Client(config);
    }
    /*钉钉-TB接口*/


    //获取TB企业成员列表（===TEST===）
    @Override
    public String getUserList() {

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/org/member/list?orgId=" + tbOrganizationId)
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                //TB应用授权码
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                //租户类型，默认为 organization
                .addHeader("X-Tenant-Type", "organization")
                .build();
        try {
            Response response = client.newCall(request).execute();
            body = response.body().string();
            JSONObject jsonObject = JSON.parseObject(body);
            System.out.println("返回体body：" + jsonObject);
        }catch (IOException e){
            e.printStackTrace();
        }

        return body;
    }

    //批量获取TB企业成员（目前仅用作查询TB某个人员的信息）
    @Override
    public String userGet(String userId){

        //1、将TB的userid放在数组中
        List list = new ArrayList();
        list.add(userId);
        System.out.println("list：" + list);
        //2、将TB接口指定传入的body请求体封装成集合
        Map map = new HashMap();
        map.put("orgId",tbOrganizationId);
        map.put("userIds",list);
        String userBody = JSON.toJSONString(map);
        System.out.println("userBody：" + userBody);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        //传入上面封装好的userBody请求体
        RequestBody body = RequestBody
                .create(mediaType, userBody);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/org/member/batchGet")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                //TB应用授权码
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                //租户类型，默认为 organization
                .addHeader("X-Tenant-Type", "organization")
                .build();

        String name = null;
        String phone = null;
        try {
            Response response = client.newCall(request).execute();
            result = response.body().string();
            JSONObject jsonObject = JSON.parseObject(result);
            System.out.println("返回结果result：" + jsonObject);

            JSONArray result = jsonObject.getJSONArray("result");
            System.out.println("解析数组result：" + result);
            name = result.getJSONObject(0).getString("name");
            System.out.println("提取name：" + name);
            String phone1 = result.getJSONObject(0).getString("phone");
            System.out.println("接口返回的手机号：" + phone1);
            phone = phone1.substring(3);
            System.out.println("提取phone：" + phone);
        }catch (IOException e){
            e.printStackTrace();
        }

        //【钉钉：根据手机号查询用户】
        String dingUserId = null;
        try {
            DingTalkClient client1 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/user/getbymobile");
            OapiV2UserGetbymobileRequest req = new OapiV2UserGetbymobileRequest();
            req.setMobile(phone);
            OapiV2UserGetbymobileResponse rsp = client1.execute(req, accessTokenService.getAccessToken());
            System.out.println(rsp.getBody());
            dingUserId = JSON.parseObject(rsp.getBody()).getJSONObject("result").getString("userid");
            System.out.println("钉钉userid（和宜搭一致）：" + dingUserId);
        } catch (ApiException e) {
            e.printStackTrace();
        }

        return dingUserId;
    }


    /*根据宜搭人员姓名匹配获取TB人员ID【不需要】*/
//    public String getUserIdForTB(String userName){
//        log.info("获取待查询人员姓名：" + userName);
//
//        //调用TB搜索企业成员接口获取TB人员ID
//        OkHttpClient client = new OkHttpClient().newBuilder()
//                .build();
//        Request request = new Request.Builder()
//                .url("https://open.teambition.com/api/org/member/search?orgId="+ tbOrganizationId +"&query=" + userName)
//                .method("GET", null)
//                .addHeader("Content-Type", "application/json")
//                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
//                .addHeader("X-Tenant-Id", tbOrganizationId)
//                .addHeader("X-Tenant-Type", "organization")
//                .build();
//
//        String body = null;
//        String userId = null;
//        try {
//            Response response = client.newCall(request).execute();
//            body = response.body().string();
//            JSONObject jsonObject = JSON.parseObject(body);
//            System.out.println("返回体body：" + jsonObject);
//            //TODO 【需要注意：可能存在重名的情况，目前只获取返回结果的第一个人员】
//            JSONArray result = jsonObject.getJSONArray("result");
//            if (result.isEmpty()){
//                log.info("查询该人员姓名返回结果为空！");
//            }else {
//                userId = result.getJSONObject(0).getString("userId");
//            }
//            System.out.println("接口返回的TB人员userId：" + userId);
//        }catch (IOException e){
//            e.printStackTrace();
//        }
//        return userId;
//    }
    /*根据宜搭人员姓名匹配获取TB人员ID*/



    /*查询钉钉用户详情，获取钉钉人员姓名*/
    public String getUserName(String userid){

        String userName = null;
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/user/get");
            OapiV2UserGetRequest req = new OapiV2UserGetRequest();
            //待查询人员姓名的userid
            req.setUserid(userid);
            OapiV2UserGetResponse rsp = client.execute(req, accessTokenService.getAccessToken());
//            System.out.println(rsp.getBody());
            userName = JSON.parseObject(rsp.getBody()).getJSONObject("result").getString("name");
            System.out.println("获取的钉钉人员姓名：" + userName);
        } catch (ApiException e) {
            e.printStackTrace();
        }

        return userName;
    }
    /*查询钉钉用户详情，获取钉钉人员姓名*/



    /*根据宜搭人员userid匹配获取TB人员ID*/
    public String getTBuserId(String userid){

        String tbUserId = null;
        try {
            com.aliyun.dingtalkproject_1_0.Client client = createClient();
            com.aliyun.dingtalkproject_1_0.models.GetTbUserIdByStaffIdHeaders getTbUserIdByStaffIdHeaders = new com.aliyun.dingtalkproject_1_0.models.GetTbUserIdByStaffIdHeaders();
            getTbUserIdByStaffIdHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkproject_1_0.models.GetTbUserIdByStaffIdRequest getTbUserIdByStaffIdRequest = new com.aliyun.dingtalkproject_1_0.models.GetTbUserIdByStaffIdRequest()
                    //待查询钉钉人员的userid
                    .setUserId(userid)
                    //操作人员userid
                    .setOptUserId(userid);
            GetTbUserIdByStaffIdResponse tbUserIdByStaffIdWithOptions = client.getTbUserIdByStaffIdWithOptions(getTbUserIdByStaffIdRequest, getTbUserIdByStaffIdHeaders, new RuntimeOptions());
            String s = JSON.toJSONString(tbUserIdByStaffIdWithOptions.getBody());
            JSONObject jsonObject = JSON.parseObject(s);
//            System.out.println("【创建项目】接口object对象：" + jsonObject);
            tbUserId = jsonObject.getJSONObject("result").getString("tbUserId");
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
        System.out.println("根据宜搭人员userid接口获取tbUserId：" + tbUserId);
        return tbUserId;
    }
    /*根据宜搭人员userid匹配获取TB人员ID*/

    /*二、更新项目的项目分组*/
    /*
     * 项目分组文件夹匹配（id）：
     * 综服体系：63f73214e50b640018d05ceb
     * 运营中心：63f737403830c10018d69992
     * 教育事业部：63e1ad14bc6c420017468df6
     * 交付中心：63f7378be5d4f40017df4df8
     * 软件类：63f737b59aa05900177fa970
     * 咨询类：63f7386bb3a9b90018f95788
     * 运维类：63f73863281204001863a6e1
     * 平台事业部：63e4820da597a20018bb9ab2
     * 行业解决方案中心：63f73780fa75490018668a9a
     * 呼叫中心：63fd69b99467f2001708f2f8
     * 销服体系：63f7376ba94a020018a25446
     * 实施运维：63fd8f1532ceed0018d2574c
     *
     * */

    public void updateProjectTag(String tbUserId,String xmid,String xiangmuleixing,String yewuguishu){

        String tag = null;

        /*TB项目分组id

        * 销服体系：63f7376ba94a020018a25446
        * 软件类：63f737b59aa05900177fa970
        * 咨询类：63f7386bb3a9b90018f95788
        * 运维类：63f73863281204001863a6e1
        * 教育事业部：63e1ad14bc6c420017468df6
        * 平台事业部：63e4820da597a20018bb9ab2
        * 行业解决方案中心：63f73780fa75490018668a9a

        * */

        //根据项目类型判断放在哪个分组
        if (yewuguishu.equals("销服")){
            if (xiangmuleixing.equals("实施型项目")){
                tag = "63f737b59aa05900177fa970";
            }else if (xiangmuleixing.equals("二开型项目")){
                tag = "63f737b59aa05900177fa970";
            }else if (xiangmuleixing.equals("开发型项目")){
                tag = "63f737b59aa05900177fa970";
            }else if (xiangmuleixing.equals("完整型咨询项目")){
                tag = "63f7386bb3a9b90018f95788";
            }else if (xiangmuleixing.equals("简易型咨询项目")){
                tag = "63f7386bb3a9b90018f95788";
            }else if (xiangmuleixing.equals("运维项目")){
                tag = "63f73863281204001863a6e1";
            }
            else if (xiangmuleixing.equals("教育软件项目")){
                tag = "63f737b59aa05900177fa970";
            }else if (xiangmuleixing.equals("课程培训项目")){
                tag = "63f73780fa75490018668a9a";
            }else if (xiangmuleixing.equals("内部产品研发项目")){
                tag = "63f73780fa75490018668a9a";
            }
        }else if (yewuguishu.equals("平台")){
            tag = "63e4820da597a20018bb9ab2";
        }else if (yewuguishu.equals("教育")){
            tag = "63e1ad14bc6c420017468df6";
        }


        //封装的待更新的项目分组信息
        List list = new ArrayList();
        list.add(tag);
        Map map = new HashMap();
        map.put("projectTagIds",list);
        String mapStr = JSON.toJSONString(map);
        System.out.println("封装的待更新的项目分组信息：" + mapStr);


        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, mapStr);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/"+ xmid +"/project-tag")
                .method("PUT", body)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("x-operator-id", tbUserId)
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新更新项目的项目分组接口返回的状态码（200成功，400异常）：" + code);
    }

    /*二、更新项目的项目分组*/

    /*更新TB概览自定义字段*/
    public void updateCustomfieldId(String xmid,String tbuserId,String title,String customfieldName){
        log.info("开始执行更新TB概览自定义字段...");
        System.out.println("【项目ID】" + xmid + "【TBuserId】" + tbuserId
                + "【待更新字段内容】" + title + "【待更新的TB字段名称】" + customfieldName);


        List list = new ArrayList();
        Map map = new HashMap();
        map.put("id","");
        //待更新字段内容
        map.put("title",title);
        list.add(map);

        Map mapAll = new HashMap();
        //项目概览字段ID
        mapAll.put("customfieldName",customfieldName);
        mapAll.put("value",list);

        String bodyJsonStr = JSON.toJSONString(mapAll);
        System.out.println("封装待更新概览字段后，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                //路径参数传入：项目ID
                .url("https://open.teambition.com/api/v3/project/"+ xmid +"/status/customfield/create")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                //操作人员ID（TB人员的ID）
                .addHeader("x-operator-id", tbuserId)
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新项目概览接口返回的状态码（200成功，400异常）：" + code);
    }
    /*更新TB概览自定义字段*/



    /*获取项目角色列表（主要用于获取项目经理的角色id）*/
    public String getJueseID(String xmid){
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/" + xmid + "/role")
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        String jueseID = null;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            for (int i = 0; i < result.size(); i++) {
                String name = result.getJSONObject(i).getString("name");
                String id = result.getJSONObject(i).getString("id");
                if (name.equals("项目经理")){
                    jueseID = id;
                }
            }
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("获取项目角色列表（主要用于获取项目经理的角色id）接口返回的状态码（200成功，400异常）：" + code);

        return jueseID;
    }

    /*更新项目角色*/
    public void updateJuese(String xmid,String xiangmujingliID,String jueseID){

        Map map = new HashMap();
        //TB项目经理ID
        List userList = new ArrayList();
        userList.add(xiangmujingliID);
        //项目经理角色ID
        List roleList = new ArrayList();
        roleList.add(jueseID);

        map.put("userIds",userList);
        map.put("roleIds",roleList);
        String bodyJsonStr = JSON.toJSONString(map);
        System.out.println("封装更新项目角色的参数，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/" + xmid + "/member/role/assign")
                .method("POST", body)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
//            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新项目角色接口返回的状态码（200成功，400异常）：" + code);
    }


    /*获取总看板（总看板项目）的拥有者*/
    public String getYongyouzhe(String zongkanbanID){

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/query?projectIds=" + zongkanbanID)
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        String yongyouzheID = null;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            yongyouzheID = result.getJSONObject(0).getString("creatorId");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("获取总看板（总看板项目）的拥有者接口返回的状态码（200成功，400异常）：" + code);

        if (yongyouzheID == null){
            yongyouzheID = "61dd45cb346f23961bc3312e";
        }

        return yongyouzheID;
    }

    /*查询项目信息*/
    public JSONArray getXiangmuBoolean(String xmmc){
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/query?name=" + xmmc)
                .method("GET", null)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        JSONArray result = null;
//        Boolean flag = false;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            result = jsonObject.getJSONArray("result");
//            if (result.isEmpty()){
//                flag = false;//为false将标识TB不存在该项目
//            }else {
//                flag = true;//为true将标识TB存在该项目
//            }
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("查询项目信息接口返回的状态码（200成功，400异常）：" + code);
//        System.out.println("TB项目是否已存在flag为（true存在，false不存在）：" + flag);

        return result;
    }

    /*查询任务信息*/
    public String getRenwuId(String zongkanbanID,String renwumingcheng){
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/" + zongkanbanID + "/task/query?q=text ~ " + renwumingcheng)
                .method("GET", null)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        String renwuID = null;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            renwuID = result.getJSONObject(0).getString("id");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("查询任务信息接口返回的状态码（200成功，400异常）：" + code);
        System.out.println("任务ID：" + renwuID);

        return renwuID;
    }

    /*更新任务执行者*/
    public void updateRenwuzhixingzhe(String yongyouzheid,String renwuid,String zhixingzheid){

        System.out.println("拥有者id：" + yongyouzheid);
        System.out.println("任务id：" + renwuid);
        System.out.println("执行者id：" + zhixingzheid);

        Map map = new HashMap();
        map.put("executorId",zhixingzheid);
        String jsonString = JSON.toJSONString(map);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, jsonString);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/executor")
                .method("PUT", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新任务执行者接口返回的状态码（200成功，204无需更新，400异常）：" + code);
    }

    /*更新任务参与者*/
    public void updateRenwucanyuzhe(String yongyouzheid,String renwuid,List canyuzheidList){

        Map map = new HashMap();
        map.put("involveMembers",canyuzheidList);
        String jsonString = JSON.toJSONString(map);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, jsonString);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/involveMembers")
                .method("PUT", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新任务参与者接口返回的状态码（200成功，204无需更新，400异常）：" + code);
    }

    /*更新任务开始时间*/
    public void updateRenwukaishishijian(String yongyouzheid,String renwuid,String kaishishijian){

        Map map = new HashMap();
        map.put("startDate",kaishishijian);
        String jsonString = JSON.toJSONString(map);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, jsonString);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/startDate")
                .method("PUT", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新任务开始时间接口返回的状态码（200成功，204无需更新，400异常）：" + code);
    }

    /*更新任务结束时间*/
    public void updateRenwujieshushijian(String yongyouzheid,String renwuid,String jieshushijian){

        Map map = new HashMap();
        map.put("dueDate",jieshushijian);
        String jsonString = JSON.toJSONString(map);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, jsonString);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/dueDate")
                .method("PUT", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新任务结束时间接口返回的状态码（200成功，204无需更新，400异常）：" + code);
    }

    /*更新任务自定义字段*/
    public void updateRenwuzidingyiziduan(String yongyouzheid,String renwuid,String title,String customfieldName){

        List list = new ArrayList();
        Map map = new HashMap();
        map.put("id","");
        //待更新字段内容
        map.put("title",title);
        list.add(map);

        Map mapAll = new HashMap();
        //总看板项目概览字段ID
        mapAll.put("customfieldName",customfieldName);
        mapAll.put("value",list);

        String bodyJsonStr = JSON.toJSONString(mapAll);
        System.out.println("封装待更新任务概览字段后，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/customfield/update")
                .method("POST", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新【"+customfieldName+"】接口返回的状态码（200成功，400异常）：" + code);
    }

    /*创建总看板的子任务*/
    public void createTask(String xmid,String tbuserId,String xiangmumingcheng,
                           String zhixingzheid,List canyuzheidList,String startDate,String stopDate,
                           List zidingyiziduan){
        log.info("开始执行创建总看板的子任务...");
        System.out.println("【项目ID】" + xmid + "【TBuserId】" + tbuserId
                + "【项目名称】" + xiangmumingcheng
                + "【执行者id】" + zhixingzheid + "【参与者id列表】" + canyuzheidList
                + "【开始时间】" + startDate + "【结束时间】" + stopDate
                + "【自定义字段】" + zidingyiziduan);


        Map map = new HashMap();
        //项目id
        map.put("projectId",xmid);
        //任务标题（也就是项目名称）
        map.put("content",xiangmumingcheng);
        //执行者id（项目经理的id）
        map.put("executorId",zhixingzheid);
        //参与者id列表
        map.put("involveMembers",canyuzheidList);
        //开始时间
        map.put("startDate",startDate);
        //结束时间
        map.put("dueDate",stopDate);
        //自定义字段列表
        map.put("customfields",zidingyiziduan);

        String bodyJsonStr = JSON.toJSONString(map);
        System.out.println("封装创建总看板子任务的参数，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                //路径参数传入：项目ID
                .url("https://open.teambition.com/api/v3/task/create")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                //操作人员ID（TB人员的ID）
                .addHeader("x-operator-id", tbuserId)//TODO 对应的总看板项目的拥有者id
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("创建总看板的子任务接口返回的状态码（200成功，400异常）：" + code);
    }
    /*更新TB概览自定义字段*/


    //根据模板创建TB项目
    @Override
    public String createProject(String userId,String xiangmuchengyuanList,String xiangmujingli,String chanpinfenlei,
                                String yewuguishu,String quyu,String shishizhuti,String hetongguishu,
                                String xiaoshouleixing,String hetongbianhao,String yewuleixing,String xiangmuleixing,
                                String xiangmudengji,
                                String xiangmumingcheng,String kehuleixing,String kehumingcheng,String kehudengji,String chanpinxian,
                                String suoshusheng,String suoshushiqu,String suoshuquxian,String xiaoshourenyuanList,
                                String shouqianrenyuanList,String hetongjine,String hetongwaijine,String waibujiediaofeiyong,
                                String shifouweidailixiangmu,String qudaodailimingcheng,String yunweimoshi,String yunweiyueshu,
                                String shifouxinyetai,String startDate,String stopDate,String yunweifuzeren,
                                String wanchengriqi,
                                String DJLX,
                                String shifouyutouru,
                                String hetongtuijinzhuangtai,
                                String zhibaoyueshu,
                                String kaipiaojine,
                                String huikuanjine,
                                String kaipiaobili,
                                String huikuanbili){
        log.info("【人员userId】" + userId
                + "【项目成员List】" + xiangmuchengyuanList
                + "【项目经理】" + xiangmujingli
                + "【产品分类】" + chanpinfenlei
                + "【业务归属】" + yewuguishu
                + "【区域】" + quyu
                + "【实施主体】" + shishizhuti
                + "【合同归属】" + hetongguishu
                + "【销售类型】" + xiaoshouleixing
                + "【合同编号】" + hetongbianhao
                + "【业务类型】" + yewuleixing
                + "【项目类型】" + xiangmuleixing
                + "【项目等级】" + xiangmudengji
                + "【项目名称】" + xiangmumingcheng
                + "【客户类型】" + kehuleixing
                + "【客户名称】" + kehumingcheng
                + "【客户等级】" + kehudengji
                + "【产品线】" + chanpinxian
                + "【所属省】" + suoshusheng
                + "【所属市区】" + suoshushiqu
                + "【所属区县】" + suoshuquxian
                + "【销售人员列表】" + xiaoshourenyuanList
                + "【售前人员列表】" + shouqianrenyuanList
                + "【合同金额】" + hetongjine
                + "【合同外金额】" + hetongwaijine
                + "【外部借调费用】" + waibujiediaofeiyong
                + "【是否为代理项目】" + shifouweidailixiangmu
                + "【渠道代理名称】" + qudaodailimingcheng
                + "【运维模式】" + yunweimoshi
                + "【运维月数】" + yunweiyueshu
                + "【是否新业态】" + shifouxinyetai
                + "【开始时间】" + startDate
                + "【结束时间】" + stopDate
                + "【运维负责人】" + yunweifuzeren
                + "【完成日期（合同要求）】" + wanchengriqi
                + "【单据类型】" + DJLX//（判断使用）
                + "【是否预投入】" + shifouyutouru//（判断使用）
                + "【合同推进状态】" + hetongtuijinzhuangtai
                + "【质保月数】" + zhibaoyueshu
                + "【开票金额】" + kaipiaojine
                + "【回款金额】" + huikuanjine
                + "【开票比例】" + kaipiaobili
                + "【回款比例】" + huikuanbili);


        /*TODO 该段代码为项目如果推送重复，进行手动逐一执行*/
        String QUERY = "{\"chanpinxian\":\"传统咨询\",\"shifouweidailixiangmu\":\"否\",\"xiangmuchengyuanList\":\"[\\\"0655216340938287\\\",\\\"1720564730786469\\\",\\\"173506083326385327\\\",\\\"0316016200950255\\\",\\\"1511030625781030\\\",\\\"063102593920237268\\\",\\\"091639314021541376\\\",\\\"141965154526182392\\\",\\\"170023480521297067\\\",\\\"32533357371068557\\\",\\\"014053100236551261\\\",\\\"214737235024071374\\\"]\",\"hetongwaijine\":\"\",\"suoshuquxian\":\"\",\"yewuguishu\":\"销服\",\"shishizhuti\":\"销服-北区\",\"yewuleixing\":\"咨询\",\"yunweimoshi\":\"\",\"yunweiyueshu\":\"\",\"xiangmujingli\":\"[\\\"170023480521297067\\\"]\",\"xiaoshourenyuanList\":\"[\\\"146318090323126823\\\"]\",\"qudaodailimingcheng\":\"\",\"xiangmumingcheng\":\"2023年济南市中心城区城市污水处理设施运行年度评估项目\",\"suoshusheng\":\"山东省\",\"wanchengriqi\":\"1677513600000\",\"hetongjine\":\"415000\",\"shouqianrenyuanList\":\"[\\\"170023480521297067\\\"]\",\"shifouxinyetai\":\"否\",\"kehudengji\":\"2星\",\"userId\":\"[\\\"3036066328940020\\\"]\",\"xiangmudengji\":\"A\",\"suoshushiqu\":\"济南市\",\"kehuleixing\":\"政府部门\",\"chanpinfenlei\":\"财政绩效咨询服务\",\"quyu\":\"北区\",\"hetongbianhao\":\"2023-WZ-WZX-017\",\"xiangmuleixing\":\"完整型咨询项目\",\"hetongguishu\":\"上海闻政\",\"kehumingcheng\":\"济南市城乡水务局\",\"waibujiediaofeiyong\":\"0\",\"startDate\":\"1675180800000\",\"stopDate\":\"1677513600000\",\"xiaoshouleixing\":\"直销\"}";

        JSONObject jsonObjectTEST = JSON.parseObject(QUERY);
        System.out.println("jsonObject:" + jsonObjectTEST);

        //"【人员userId】"
        userId = jsonObjectTEST.getString("userId");
        //"【项目成员List】"
        xiangmuchengyuanList = jsonObjectTEST.getString("xiangmuchengyuanList");
        //"【项目经理】"
        xiangmujingli = jsonObjectTEST.getString("xiangmujingli");
        //"【产品分类】"
        chanpinfenlei = jsonObjectTEST.getString("chanpinfenlei");
        //"【业务归属】"
        yewuguishu = jsonObjectTEST.getString("yewuguishu");
        //"【区域】"
        quyu = jsonObjectTEST.getString("quyu");
        //"【实施主体】"
        shishizhuti = jsonObjectTEST.getString("shishizhuti");
        //"【合同归属】"
        hetongguishu = jsonObjectTEST.getString("hetongguishu");
        //"【销售类型】"
        xiaoshouleixing = jsonObjectTEST.getString("xiaoshouleixing");
        //"【合同编号】"
        hetongbianhao = jsonObjectTEST.getString("hetongbianhao");
        //"【业务类型】"
        yewuleixing = jsonObjectTEST.getString("yewuleixing");
        //"【项目类型】"
        xiangmuleixing = jsonObjectTEST.getString("xiangmuleixing");
        //"【项目等级】"
        xiangmudengji = jsonObjectTEST.getString("xiangmudengji");
        //"【项目名称】"
        xiangmumingcheng = jsonObjectTEST.getString("xiangmumingcheng");
        //"【客户类型】"
        kehuleixing = jsonObjectTEST.getString("kehuleixing");
        //"【客户名称】"
        kehumingcheng = jsonObjectTEST.getString("kehumingcheng");
        //"【客户等级】"
        kehudengji = jsonObjectTEST.getString("kehudengji");
        //"【产品线】"
        chanpinxian = jsonObjectTEST.getString("chanpinxian");
        //"【所属省】"
        suoshusheng = jsonObjectTEST.getString("suoshusheng");
        //"【所属市区】"
        suoshushiqu = jsonObjectTEST.getString("suoshushiqu");
        //"【所属区县】"
        suoshuquxian = jsonObjectTEST.getString("suoshuquxian");
        //"【销售人员列表】"
        xiaoshourenyuanList = jsonObjectTEST.getString("xiaoshourenyuanList");
        //"【售前人员列表】"
        shouqianrenyuanList = jsonObjectTEST.getString("shouqianrenyuanList");
        //"【合同金额】"
        hetongjine = jsonObjectTEST.getString("hetongjine");
        //"【合同外金额】"
        hetongwaijine = jsonObjectTEST.getString("hetongwaijine");
        //"【外部借调费用】"
        waibujiediaofeiyong = jsonObjectTEST.getString("waibujiediaofeiyong");
        //"【是否为代理项目】"
        shifouweidailixiangmu = jsonObjectTEST.getString("shifouweidailixiangmu");
        //"【渠道代理名称】"
        qudaodailimingcheng = jsonObjectTEST.getString("qudaodailimingcheng");
        //"【运维模式】"
        yunweimoshi = jsonObjectTEST.getString("yunweimoshiyunweimoshi");
        //"【运维月数】"
        yunweiyueshu = jsonObjectTEST.getString("yunweiyueshu");
        //"【是否新业态】"
        shifouxinyetai = jsonObjectTEST.getString("shifouxinyetai");
        //"【开始时间】"
        startDate = jsonObjectTEST.getString("startDate");
        //"【结束时间】"
        stopDate = jsonObjectTEST.getString("stopDate");
        //"【运维负责人】"
        yunweifuzeren = jsonObjectTEST.getString("yunweifuzeren");
        //"【完成日期（合同要求）】"
        wanchengriqi = jsonObjectTEST.getString("wanchengriqi");
        //"【单据类型】"
//        DJLX = jsonObjectTEST.getString("DJLX");
        DJLX = "合同交底";
        //"【是否预投入】"
        shifouyutouru = jsonObjectTEST.getString("shifouyutouru");
        //"【合同推进状态】"
//        hetongtuijinzhuangtai = jsonObjectTEST.getString("hetongtuijinzhuangtai");
        hetongtuijinzhuangtai = "已完成";
        //"【质保月数】"
        zhibaoyueshu = jsonObjectTEST.getString("zhibaoyueshu");

        /*TODO 该段代码为项目如果推送重复，进行手动逐一执行*/


        /*公共处理内容*/

        //根据业务归属（销服、教育、平台）判断项目模板拥有者是谁来发起
        /*钉钉指定的角色ID
            {
                "name":"平台业务负责人",
                "id":3754637916
            },
            {
                "name":"教育业务负责人",
                "id":3755082021
            },
            {
                "name":"销服业务负责人",
                "id":3755028191
            }
        * */

        //平台
        long pingtai = 3754637916L;
        //教育
        long jiaoyu = 3755082021L;
        //销服
        long xiaofu = 3755028191L;

        String dingdingUserName = null;
        String dingdingUserId = null;
        if (yewuguishu.equals("销服")){
            try {
                DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/role/simplelist");
                OapiRoleSimplelistRequest req = new OapiRoleSimplelistRequest();
                //钉钉角色ID
                req.setRoleId(xiaofu);
                OapiRoleSimplelistResponse rsp = client.execute(req, accessTokenService.getAccessToken());
//                System.out.println(rsp.getBody());
                JSONObject jsonObject = JSON.parseObject(rsp.getBody()).getJSONObject("result").getJSONArray("list").getJSONObject(0);

                dingdingUserName = jsonObject.getString("name");
                dingdingUserId = jsonObject.getString("userid");
                System.out.println("获取的钉钉销服业务负责人员信息（人员姓名、人员ID）：" + dingdingUserName + "、" + dingdingUserId);
            } catch (ApiException e) {
                e.printStackTrace();
            }

        }else if (yewuguishu.equals("教育")){

            try {
                DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/role/simplelist");
                OapiRoleSimplelistRequest req = new OapiRoleSimplelistRequest();
                //钉钉角色ID
                req.setRoleId(jiaoyu);
                OapiRoleSimplelistResponse rsp = client.execute(req, accessTokenService.getAccessToken());
//                System.out.println(rsp.getBody());
                JSONObject jsonObject = JSON.parseObject(rsp.getBody()).getJSONObject("result").getJSONArray("list").getJSONObject(0);

                dingdingUserName = jsonObject.getString("name");
                dingdingUserId = jsonObject.getString("userid");
                System.out.println("获取的钉钉销服业务负责人员信息（人员姓名、人员ID）：" + dingdingUserName + "、" + dingdingUserId);
            } catch (ApiException e) {
                e.printStackTrace();
            }
        }else {//平台

            try {
                DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/role/simplelist");
                OapiRoleSimplelistRequest req = new OapiRoleSimplelistRequest();
                //钉钉角色ID
                req.setRoleId(pingtai);
                OapiRoleSimplelistResponse rsp = client.execute(req, accessTokenService.getAccessToken());
//                System.out.println(rsp.getBody());
                JSONObject jsonObject = JSON.parseObject(rsp.getBody()).getJSONObject("result").getJSONArray("list").getJSONObject(0);

                dingdingUserName = jsonObject.getString("name");
                dingdingUserId = jsonObject.getString("userid");
                System.out.println("获取的钉钉销服业务负责人员信息（人员姓名、人员ID）：" + dingdingUserName + "、" + dingdingUserId);
            } catch (ApiException e) {
                e.printStackTrace();
            }
        }

        //操作人员ID（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
//        String userStr = userId.replace("\"", "").
//                replaceAll("\\[", "").
//                replaceAll("\\]", "");
        String userStr = dingdingUserId;//根据三大业务负责人角色获取对应的人员钉钉userId
        System.out.println("操作人员ID（钉钉ID）：" + userStr);

        //项目经理ID（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
        String userStrJingli = xiangmujingli.replace("\"", "").
                replaceAll("\\[", "").
                replaceAll("\\]", "");
        System.out.println("项目经理ID（钉钉ID）：" + userStrJingli);
        String userNameJingli = getUserName(userStrJingli);


        //项目成员List（钉钉ID）
        JSONArray jsonArray = JSON.parseArray(xiangmuchengyuanList);
        System.out.println("jsonArray：" + jsonArray);

        int size = jsonArray.size();
        System.out.println("size：" + size);
        int sizeAll = size + 1;//额外增加项目经理到项目成员中
        System.out.println("sizeAll：" + sizeAll);
        String[] strings = new String[sizeAll];

        String xiangmuchengyuanName = "";
        for (int i = 0; i < size; i++) {
//            System.out.println("第【" + i + "】次循环");
            String string = jsonArray.getString(i);
            System.out.println("循环获取项目成员id：" + string);

            strings[i] = string;

            String userNameXiangmuchengyuan = getUserName(string);
            xiangmuchengyuanName = xiangmuchengyuanName + userNameXiangmuchengyuan + " ";
        }

        strings[size] = userStrJingli;
        String userNameXiangmuchengyuan = getUserName(userStrJingli);
        xiangmuchengyuanName = xiangmuchengyuanName + userNameXiangmuchengyuan + " ";

        List<String> asList = Arrays.asList(strings);
        System.out.println("转换成asList：" + asList);


        //销售成员List（钉钉ID）
        JSONArray jsonArray1 = JSON.parseArray(xiaoshourenyuanList);
        System.out.println("jsonArray1：" + jsonArray1);

        String xiaoshourenyuanName = "";
        for (int i1 = 0; i1 < jsonArray1.size(); i1++) {
            String string1 = jsonArray1.getString(i1);
            System.out.println("循环获取销售人员姓名：" + string1);
            String userNameXiaoshouchengyuan = getUserName(string1);
            xiaoshourenyuanName = xiaoshourenyuanName + userNameXiaoshouchengyuan + " ";
        }
        System.out.println("最终拼接的销售人员姓名列表：" + xiaoshourenyuanName);

        //运维负责人ID（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
        String userNameYunweifuzeren = "";
        if (yunweifuzeren != null) {
            String userStrYunweifuzeren = yunweifuzeren.replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");
            System.out.println("运维负责人ID（钉钉ID）：" + userStrYunweifuzeren);
            userNameYunweifuzeren = getUserName(userStrYunweifuzeren);
        }

        //售前人员ID（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
        String userNameShouqianrenyuan = "";
        if (yunweifuzeren != null) {
            String userStrShouqianrenyuan = shouqianrenyuanList.replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");
            System.out.println("售前人员ID（钉钉ID）：" + userStrShouqianrenyuan);
            userNameShouqianrenyuan = getUserName(userStrShouqianrenyuan);
        }


        //封装项目参与人员TBid列表
        List list = new ArrayList();
        for (int c = 0; c < jsonArray.size(); c++) {
            String string = jsonArray.getString(c);
            System.out.println("循环获取项目成员id：" + string);

            String tBuserIdCanyu = getTBuserId(string);
            list.add(tBuserIdCanyu);
        }
        System.out.println("封装的项目参与人员TBid列表：" + list);

        //时间戳转换成时间型
        //yyyy-MM-dd HH:mm:ss 转换的时间格式  可以自定义
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //转换 【开始时间】
        String startTime = sdf.format(new Date(Long.parseLong(startDate)));
        System.out.println("转换 【开始时间】" + startTime);
        //转换 【结束时间】
        String stopTime = sdf.format(new Date(Long.parseLong(stopDate)));
        System.out.println("转换 【结束时间】" + stopTime);

        //转换【完成日期 （合同要求）】
        String wanchengTime = sdf.format(new Date(Long.parseLong(wanchengriqi)));
        /*公共处理内容*/


        /*传参示例*/
//        【人员userId】["011033176057775267"]
//        【项目成员List】["011467460262746600","0806565327692090"]
//        【业务归属】销服
//        【区域】北区
//        【实施主体】销服-东区
//        【合同归属】上海闻政
//        【销售类型】直销
//        【合同编号】2023-WZ-WZX-043
//        【业务类型】咨询
//        【项目类型】实施型项目
//        【项目名称】2023上海城投老港基地公交轨交
//        【客户名称】上海城投老港基地管理有限公司
//        【客户等级】3星
//        【产品线】公交轨交
//        【所属省】上海市
//        【所属市区】上海市
//        【所属区县】浦东新区
//        【销售人员列表】["011033176057775267"]
//        【售前人员列表】["011467460262746600"]
//        【合同金额】123
//        【合同外金额】
//        【外部借调费用】111
//        【是否为代理项目】是
//        【渠道代理名称】【测试】渠道（代理）名称
//        【运维模式】
//        【运维月数】
//        【是否新业态】是

        //判断在TB中是否已经存在该项目名称
        JSONArray xiangmuResult = getXiangmuBoolean(xiangmumingcheng);
        System.out.println("查询TB中是否存在该项目名称，接口返回信息：" + xiangmuResult);

        if (DJLX.equals("合同交底") || DJLX.equals("合同变更")) {
            log.info("===开始进入【合同交底】业务执行===");


            //是否放入回收站（false没放入回收站；true已放入回收站）
            Boolean flag = false;

            if (xiangmuResult.isEmpty()){
                flag = false;//为false将标识TB不存在该项目
            }else {
                Boolean isArchived = xiangmuResult.getJSONObject(0).getBoolean("isArchived");
                if (isArchived == true){
                    System.out.println("该项目已放入回收站！将视为不存在该项目！");
                    flag = false;
                }else {
                    flag = true;//为true将标识TB存在该项目
                }
            }

            if (1 == 1){
                log.info("TB中已经存在该项目，开始执行更新操作···");

                //已存在的项目id
//                String xmid = xiangmuResult.getJSONObject(0).getString("id");
                String xmid = "640ed7f3903f89a002ef1f07";//手动执行的项目id
                System.out.println("已存在的项目id：" + xmid);

                /*获取项目拥有者（TB人员id）*/
                String yongyouzhe1 = getYongyouzhe(xmid);

                /*三、根据项目ID更新项目成员*/
                log.info("开始执行根据项目ID更新项目成员...");
                JSONObject jsonObject1 = null;
                try {
                    com.aliyun.dingtalkproject_1_0.Client client = createClient();
                    com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders addProjectMemberHeaders = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders();
                    addProjectMemberHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                    com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest addProjectMemberRequest = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest()
                            //项目成员userId列表
                            .setUserIds(asList);

                    //参数一：操作人员userId；
                    //参数二：项目ID
                    AddProjectMemberResponse addProjectMemberResponse = client.addProjectMemberWithOptions(userStr, xmid, addProjectMemberRequest, addProjectMemberHeaders, new RuntimeOptions());
                    String s = JSON.toJSONString(addProjectMemberResponse.getBody());
                    jsonObject1 = JSON.parseObject(s);
                    System.out.println("【更新项目成员】接口object对象：" + jsonObject1);
                } catch (TeaException err) {
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                } catch (Exception _err) {
                    TeaException err = new TeaException(_err.getMessage(), _err);
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                }

                /*根据宜搭项目经理人员userid匹配获取TB人员ID*/
                log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
                String tBuserIdJingli = getTBuserId(userStrJingli);

                /*四、根据项目ID更新项目经理角色*/
                log.info("开始执行根据项目ID获取项目经理角色ID...");
                String jueseID = getJueseID(xmid);
                log.info("开始执行根据项目ID更新项目经理角色...");
                updateJuese(xmid, tBuserIdJingli, jueseID);


                /*根据宜搭人员userid匹配获取TB人员ID*/
                log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
                String tBuserId = getTBuserId(userStr);

                /*更新项目分组文件夹*/
                log.info("开始执行更新项目分组文件夹...");
                updateProjectTag(yongyouzhe1, xmid, xiangmuleixing, yewuguishu);


                /*更新项目概览字段*/
                log.info("开始执行多次更新项目概览字段...");
                //产品分类
                log.info("开始更新写入【产品分类】");
                updateCustomfieldId(xmid, yongyouzhe1, chanpinfenlei, "产品分类");
                //是否新业态
                log.info("开始更新写入【是否新业态】");
                updateCustomfieldId(xmid, yongyouzhe1, shifouxinyetai, "是否新业态");
                //产品线
                log.info("开始更新写入【产品线】");
                updateCustomfieldId(xmid, yongyouzhe1, chanpinxian, "产品线");
                //业务归属
                log.info("开始更新写入【业务归属】");
                updateCustomfieldId(xmid, yongyouzhe1, yewuguishu, "业务归属");
                //区域
                log.info("开始更新写入【区域】");
                updateCustomfieldId(xmid, yongyouzhe1, quyu, "区域");
                //实施牵头主体
                log.info("开始更新写入【实施牵头主体】");
                updateCustomfieldId(xmid, yongyouzhe1, shishizhuti, "实施牵头主体");
                //项目类型
                log.info("开始更新写入【项目类型】");
                updateCustomfieldId(xmid, yongyouzhe1, xiangmuleixing, "项目类型");
                //项目等级
                log.info("开始更新写入【项目等级】");
                updateCustomfieldId(xmid, yongyouzhe1, xiangmudengji, "项目等级");
                //客户名称
                log.info("开始更新写入【客户名称】");
                updateCustomfieldId(xmid, yongyouzhe1, kehumingcheng, "客户名称");
                //客户类型
                log.info("开始更新写入【客户名称】");
                updateCustomfieldId(xmid, yongyouzhe1, kehuleixing, "客户类型");
                //客户等级
                log.info("开始更新写入【客户等级】");
                updateCustomfieldId(xmid, yongyouzhe1, kehudengji, "客户等级");
                //所属省
                log.info("开始更新写入【所属省】");
                updateCustomfieldId(xmid, yongyouzhe1, suoshusheng, "所属省");
                //所属市区
                log.info("开始更新写入【所属市区】");
                updateCustomfieldId(xmid, yongyouzhe1, suoshushiqu, "所属市区");
                //所属区县
                log.info("开始更新写入【所属区县】");
                updateCustomfieldId(xmid, yongyouzhe1, suoshuquxian, "所属区县");
                //项目经理
                log.info("开始更新写入【项目经理】");
                updateCustomfieldId(xmid, yongyouzhe1, userNameJingli, "项目经理");
                //销售人员
                log.info("开始更新写入【销售人员】");
                updateCustomfieldId(xmid, yongyouzhe1, xiaoshourenyuanName, "销售人员");
                //项目成员
                log.info("开始更新写入【项目成员】");
                updateCustomfieldId(xmid, yongyouzhe1, xiangmuchengyuanName, "项目成员");


                //合同编号
                log.info("开始更新写入【合同编号】");
                updateCustomfieldId(xmid, yongyouzhe1, hetongbianhao, "合同编号");

                //获取总看板下该项目名称的任务ID
                //总看板项目id
                String ZongkanbanId = null;
                //拥有者id
                String yongyouzhe = null;
                //判断项目类型对应的TB对应的总看板项目ID
                if (xiangmuleixing.equals("实施型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("二开型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("开发型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("完整型咨询项目")) {

                    ZongkanbanId = "63c64671432c0b7bbba01c48";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("简易型咨询项目")) {

                    ZongkanbanId = "63c64671432c0b7bbba01c48";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("运维项目")) {

                    ZongkanbanId = "63c64924df32b699b98cf049";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                }
//                else if (xiangmuleixing.equals("教育软件项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("课程培训项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("内部产品研发项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                }

                //任务ID
//                String renwuId = getRenwuId(ZongkanbanId, xiangmumingcheng);
                String renwuId = "6413cea7e995456699c7a5b5";//手动执行的对应的项目任务id

                //更新任务执行者（项目经理）
                updateRenwuzhixingzhe(yongyouzhe,renwuId,tBuserIdJingli);

                //更新任务参与者（项目成员）
                updateRenwucanyuzhe(yongyouzhe,renwuId,list);

                //更新任务开始时间
                updateRenwukaishishijian(yongyouzhe,renwuId,startTime);

                //更新任务结束时间
                updateRenwukaishishijian(yongyouzhe,renwuId,stopTime);

                /*更新总看板任务自定义字段*/
                //产品分类
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,chanpinfenlei,"产品分类");

                //是否新业态
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,shifouxinyetai,"是否新业态");

                //产品线
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,chanpinxian,"产品线");

                //业务归属
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,yewuguishu,"业务归属");

                //区域
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,quyu,"区域");

                //实施牵头主体
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,shishizhuti,"实施牵头主体");

                //合同归属
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,hetongguishu,"合同归属");

                //销售类型
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiaoshouleixing,"销售类型");

                //合同编号
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,hetongbianhao,"合同编号");

//        //合同分类


                //项目类型
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiangmuleixing,"项目类型");

                //项目名称
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiangmumingcheng,"项目名称");

                //项目等级
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiangmudengji,"项目等级");

                //客户名称
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,kehumingcheng,"客户名称");

                //客户类型
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,kehuleixing,"客户类型");

                //客户等级
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,kehudengji,"客户等级");

                //所属省
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,suoshusheng,"所属省");

                //所属市区
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,suoshushiqu,"所属市区");

                //所属区县
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,suoshuquxian,"所属区县");

                //是否为代理项目
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,shifouweidailixiangmu,"是否为代理项目");

                //渠道（代理）名称
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,qudaodailimingcheng,"渠道（代理）名称");

                //销售人员
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiaoshourenyuanName,"销售人员");

                //运维负责人
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,userNameYunweifuzeren,"运维负责人");

                //运维月数
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,yunweiyueshu,"运维月数");

                //合同金额 （元）
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,hetongjine,"合同金额 （元）");

                //项目经理
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,userNameJingli,"项目经理");

                //项目成员
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,xiangmuchengyuanName,"项目成员");

                //完成日期 （合同要求）
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,wanchengriqi,"完成日期 （合同要求）");

                //质保月数
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,zhibaoyueshu,"质保月数");

                //合同推进状态
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,hetongtuijinzhuangtai,"合同推进状态");
                //【说明：针对合同交底表单提交的单据，该字段默认传“已完成”；预投入交底表单传表单对应的控件值】

                //售前人员
                updateRenwuzidingyiziduan(yongyouzhe,renwuId,userNameShouqianrenyuan,"售前人员");


                System.out.println("更新TB已存在项目信息完成（合同交底）！");
                return "更新TB已存在项目信息完成（合同交底）！";
            }else {
                log.info("TB中不存在该项目，开始执行新增操作···");

                /*
                 * 模板定义（ID）
                 *
                 * 交付中心（二开型项目模板）：63fd678ccab2960018ddb394
                 * 交付中心（简易型咨询项目模板）：63fd67c7806fae0017a8800f
                 * 交付中心（实施型项目模板）：63fd67eaba9b960018ff8b12
                 * 交付中心（完整型咨询项目模板）：63fd680cdf94010017d80712
                 * 交付中心（研发型项目模板）：63fd682b72396e00186d9287
                 * 交付中心（运维型项目模板）：63fd687140558f0018105345
                 *
                 * 教育项目模版：63e065d0fe8217001780785f
                 * 教育事业部项目-模板项目：63fda913ed5a640018eac515
                 * 教育事业部-咨询项目模板：640aa043b36b11001849dff4
                 * 教育事业部-研发型任务模板：640e84795ab52c0017e508ea
                 *
                 * 交付总看板（软件类） 模板：640ebb5effa4d40018ea5cc5
                 * 交付总看板（运维） 模板：640ebb8f3e07ec00187d9c58
                 * 交付总看板（咨询）模板：640ebbe0c8335700184485de
                 *
                 * 平台事业部项目模板-课程培训项目：64269ad55135aeb5c9786131
                 * */


                //模板ID
                String TemplateId = null;

                //判断项目类型对应的TB项目模板ID
                if (xiangmuleixing.equals("实施型项目")) {

                    TemplateId = "63fd67eaba9b960018ff8b12";

                } else if (xiangmuleixing.equals("二开型项目")) {

                    TemplateId = "63fd678ccab2960018ddb394";

                } else if (xiangmuleixing.equals("开发型项目")) {

                    TemplateId = "63fd682b72396e00186d9287";

                } else if (xiangmuleixing.equals("完整型咨询项目")) {

                    TemplateId = "63fd680cdf94010017d80712";

                } else if (xiangmuleixing.equals("简易型咨询项目")) {

                    TemplateId = "63fd67c7806fae0017a8800f";

                } else if (xiangmuleixing.equals("运维项目")) {

                    TemplateId = "63fd687140558f0018105345";

                } else if (xiangmuleixing.equals("教育软件项目")) {
                    TemplateId = "63fda913ed5a640018eac515";
                } else if (xiangmuleixing.equals("课程培训项目")) {
                    TemplateId = "64269ad55135aeb5c9786131";
                } else if (xiangmuleixing.equals("内部产品研发项目")) {
                    TemplateId = "63fc661c6ac87b00175c5c3d";
                }

                /*一、根据模板创建TB项目*/
                log.info("开始执行根据模板创建TB项目...");
                JSONObject jsonObject = null;
                try {
                    com.aliyun.dingtalkproject_1_0.Client client = createClient();
                    com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders createProjectByTemplateHeaders = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders();
                    createProjectByTemplateHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                    com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest createProjectByTemplateRequest = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest()
                            //项目名称
                            .setName(xiangmumingcheng)
                            //模板ID
                            .setTemplateId(TemplateId);

                    //操作人员userId（目前统一默认【郑晓峰61dd45cc5eeb5025ebd13ff1】为项目创建人）
                    CreateProjectByTemplateResponse projectByTemplateWithOptions = client.createProjectByTemplateWithOptions(userStr, createProjectByTemplateRequest, createProjectByTemplateHeaders, new RuntimeOptions());
                    String s = JSON.toJSONString(projectByTemplateWithOptions.getBody());
                    jsonObject = JSON.parseObject(s);
                    System.out.println("【创建项目】接口object对象：" + jsonObject);
                } catch (TeaException err) {
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                } catch (Exception _err) {
                    TeaException err = new TeaException(_err.getMessage(), _err);
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                }
                System.out.println("【创建项目】接口object对象：" + jsonObject);
                String xiangmuId = jsonObject.getJSONObject("result").getString("id");
                System.out.println("【创建项目】接口object对象返回的【项目ID】：" + xiangmuId);


                /*三、根据项目ID更新项目成员*/
                log.info("开始执行根据项目ID更新项目成员...");
                JSONObject jsonObject1 = null;
                try {
                    com.aliyun.dingtalkproject_1_0.Client client = createClient();
                    com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders addProjectMemberHeaders = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders();
                    addProjectMemberHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                    com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest addProjectMemberRequest = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest()
                            //项目成员userId列表
                            .setUserIds(asList);

                    //参数一：操作人员userId；
                    //参数二：项目ID
                    AddProjectMemberResponse addProjectMemberResponse = client.addProjectMemberWithOptions(userStr, xiangmuId, addProjectMemberRequest, addProjectMemberHeaders, new RuntimeOptions());
                    String s = JSON.toJSONString(addProjectMemberResponse.getBody());
                    jsonObject1 = JSON.parseObject(s);
                    System.out.println("【更新项目成员】接口object对象：" + jsonObject1);
                } catch (TeaException err) {
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                } catch (Exception _err) {
                    TeaException err = new TeaException(_err.getMessage(), _err);
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }
                }

                /*根据宜搭项目经理人员userid匹配获取TB人员ID*/
                log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
                String tBuserIdJingli = getTBuserId(userStrJingli);

                /*四、根据项目ID更新项目经理角色*/
                log.info("开始执行根据项目ID获取项目经理角色ID...");
                String jueseID = getJueseID(xiangmuId);
                log.info("开始执行根据项目ID更新项目经理角色...");
                updateJuese(xiangmuId, tBuserIdJingli, jueseID);


                /*根据宜搭人员userid匹配获取TB人员ID*/
                log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
                String tBuserId = getTBuserId(userStr);

                /*更新项目分组文件夹*/
                log.info("开始执行更新项目分组文件夹...");
                updateProjectTag(tBuserId, xiangmuId, xiangmuleixing, yewuguishu);


                /*创建任务到对应的总看板*/
                /*
                 * 总看板项目ID
                 *
                 * 交付总看板（软件类）：63c4ea646ff268bcab3f82b3
                 * 交付总看板（咨询）：63c64671432c0b7bbba01c48
                 * 交付总看板（运维）：63c64924df32b699b98cf049
                 *
                 * */


                /*根据宜搭项目参与人员useridList匹配获取多个TB人员ID*/
                log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");



                List listAll = new ArrayList();
                //产品分类
                Map mapValue1 = new HashMap();
                mapValue1.put("id", "");
                mapValue1.put("title", chanpinfenlei);

                List listValue1 = new ArrayList();
                listValue1.add(mapValue1);

                Map map1 = new HashMap();
                map1.put("customfieldName", "产品分类");
                map1.put("value", listValue1);
                //是否新业态
                Map mapValue2 = new HashMap();
                mapValue2.put("id", "");
                mapValue2.put("title", shifouxinyetai);

                List listValue2 = new ArrayList();
                listValue2.add(mapValue2);

                Map map2 = new HashMap();
                map2.put("customfieldName", "是否新业态");
                map2.put("value", listValue2);
                //产品线
                Map mapValue3 = new HashMap();
                mapValue3.put("id", "");
                mapValue3.put("title", chanpinxian);

                List listValue3 = new ArrayList();
                listValue3.add(mapValue3);

                Map map3 = new HashMap();
                map3.put("customfieldName", "产品线");
                map3.put("value", listValue3);
                //业务归属
                Map mapValue4 = new HashMap();
                mapValue4.put("id", "");
                mapValue4.put("title", yewuguishu);

                List listValue4 = new ArrayList();
                listValue4.add(mapValue4);

                Map map4 = new HashMap();
                map4.put("customfieldName", "业务归属");
                map4.put("value", listValue4);
                //区域
                Map mapValue5 = new HashMap();
                mapValue5.put("id", "");
                mapValue5.put("title", quyu);

                List listValue5 = new ArrayList();
                listValue5.add(mapValue5);

                Map map5 = new HashMap();
                map5.put("customfieldName", "区域");
                map5.put("value", listValue5);
                //实施牵头主体
                Map mapValue6 = new HashMap();
                mapValue6.put("id", "");
                mapValue6.put("title", shishizhuti);

                List listValue6 = new ArrayList();
                listValue6.add(mapValue6);

                Map map6 = new HashMap();
                map6.put("customfieldName", "实施牵头主体");
                map6.put("value", listValue6);
                //合同归属
                Map mapValue7 = new HashMap();
                mapValue7.put("id", "");
                mapValue7.put("title", hetongguishu);

                List listValue7 = new ArrayList();
                listValue7.add(mapValue7);

                Map map7 = new HashMap();
                map7.put("customfieldName", "合同归属");
                map7.put("value", listValue7);
                //销售类型
                Map mapValue8 = new HashMap();
                mapValue8.put("id", "");
                mapValue8.put("title", xiaoshouleixing);

                List listValue8 = new ArrayList();
                listValue8.add(mapValue8);

                Map map8 = new HashMap();
                map8.put("customfieldName", "销售类型");
                map8.put("value", listValue8);
                //合同编号
                Map mapValue9 = new HashMap();
                mapValue9.put("id", "");
                mapValue9.put("title", hetongbianhao);

                List listValue9 = new ArrayList();
                listValue9.add(mapValue9);

                Map map9 = new HashMap();
                map9.put("customfieldName", "合同编号");
                map9.put("value", listValue9);
//        //合同分类
//        Map mapValue10 = new HashMap();
//        mapValue10.put("id","");
//        mapValue10.put("title",);
                //项目类型
                Map mapValue11 = new HashMap();
                mapValue11.put("id", "");
                mapValue11.put("title", xiangmuleixing);

                List listValue11 = new ArrayList();
                listValue11.add(mapValue11);

                Map map11 = new HashMap();
                map11.put("customfieldName", "项目类型");
                map11.put("value", listValue11);
                //项目名称
                Map mapValue12 = new HashMap();
                mapValue12.put("id", "");
                mapValue12.put("title", xiangmumingcheng);

                List listValue12 = new ArrayList();
                listValue12.add(mapValue12);

                Map map12 = new HashMap();
                map12.put("customfieldName", "项目名称");
                map12.put("value", listValue12);
                //项目等级
                Map mapValue13 = new HashMap();
                mapValue13.put("id", "");
                mapValue13.put("title", xiangmudengji);

                List listValue13 = new ArrayList();
                listValue13.add(mapValue13);

                Map map13 = new HashMap();
                map13.put("customfieldName", "项目等级");
                map13.put("value", listValue13);
                //客户名称
                Map mapValue14 = new HashMap();
                mapValue14.put("id", "");
                mapValue14.put("title", kehumingcheng);

                List listValue14 = new ArrayList();
                listValue14.add(mapValue14);

                Map map14 = new HashMap();
                map14.put("customfieldName", "客户名称");
                map14.put("value", listValue14);
                //客户类型
                Map mapValue15 = new HashMap();
                mapValue15.put("id", "");
                mapValue15.put("title", kehuleixing);

                List listValue15 = new ArrayList();
                listValue15.add(mapValue15);

                Map map15 = new HashMap();
                map15.put("customfieldName", "客户类型");
                map15.put("value", listValue15);
                //客户等级
                Map mapValue16 = new HashMap();
                mapValue16.put("id", "");
                mapValue16.put("title", kehudengji);

                List listValue16 = new ArrayList();
                listValue16.add(mapValue16);

                Map map16 = new HashMap();
                map16.put("customfieldName", "客户等级");
                map16.put("value", listValue16);
                //所属省
                Map mapValue17 = new HashMap();
                mapValue17.put("id", "");
                mapValue17.put("title", suoshusheng);

                List listValue17 = new ArrayList();
                listValue17.add(mapValue17);

                Map map17 = new HashMap();
                map17.put("customfieldName", "所属省");
                map17.put("value", listValue17);
                //所属市区
                Map mapValue18 = new HashMap();
                mapValue18.put("id", "");
                mapValue18.put("title", suoshushiqu);

                List listValue18 = new ArrayList();
                listValue18.add(mapValue18);

                Map map18 = new HashMap();
                map18.put("customfieldName", "所属市区");
                map18.put("value", listValue18);
                //所属区县
                Map mapValue19 = new HashMap();
                mapValue19.put("id", "");
                mapValue19.put("title", suoshuquxian);

                List listValue19 = new ArrayList();
                listValue19.add(mapValue19);

                Map map19 = new HashMap();
                map19.put("customfieldName", "所属区县");
                map19.put("value", listValue19);
                //是否为代理项目
                Map mapValue20 = new HashMap();
                mapValue20.put("id", "");
                mapValue20.put("title", shifouweidailixiangmu);

                List listValue20 = new ArrayList();
                listValue20.add(mapValue20);

                Map map20 = new HashMap();
                map20.put("customfieldName", "是否为代理项目");
                map20.put("value", listValue20);
                //渠道（代理）名称
                Map mapValue21 = new HashMap();
                mapValue21.put("id", "");
                mapValue21.put("title", qudaodailimingcheng);

                List listValue21 = new ArrayList();
                listValue21.add(mapValue21);

                Map map21 = new HashMap();
                map21.put("customfieldName", "渠道（代理）名称");
                map21.put("value", listValue21);
                //销售人员
                Map mapValue22 = new HashMap();
                mapValue22.put("id", "");
                mapValue22.put("title", xiaoshourenyuanName);

                List listValue22 = new ArrayList();
                listValue22.add(mapValue22);

                Map map22 = new HashMap();
                map22.put("customfieldName", "销售人员");
                map22.put("value", listValue22);
                //运维负责人
                Map mapValue23 = new HashMap();
                mapValue23.put("id", "");
                mapValue23.put("title", userNameYunweifuzeren);

                List listValue23 = new ArrayList();
                listValue23.add(mapValue23);

                Map map23 = new HashMap();
                map23.put("customfieldName", "运维负责人");
                map23.put("value", listValue23);
                //运维月数
                Map mapValue24 = new HashMap();
                mapValue24.put("id", "");
                mapValue24.put("title", yunweiyueshu);

                List listValue24 = new ArrayList();
                listValue24.add(mapValue24);

                Map map24 = new HashMap();
                map24.put("customfieldName", "运维月数");
                map24.put("value", listValue24);
                //合同金额 （元）
                Map mapValue25 = new HashMap();
                mapValue25.put("id", "");
                mapValue25.put("title", hetongjine);

                List listValue25 = new ArrayList();
                listValue25.add(mapValue25);

                Map map25 = new HashMap();
                map25.put("customfieldName", "合同金额 （元）");
                map25.put("value", listValue25);
                //项目经理
                Map mapValue26 = new HashMap();
                mapValue26.put("id", "");
                mapValue26.put("title", userNameJingli);

                List listValue26 = new ArrayList();
                listValue26.add(mapValue26);

                Map map26 = new HashMap();
                map26.put("customfieldName", "项目经理");
                map26.put("value", listValue26);
                //项目成员
                Map mapValue27 = new HashMap();
                mapValue27.put("id", "");
                mapValue27.put("title", xiangmuchengyuanName);

                List listValue27 = new ArrayList();
                listValue27.add(mapValue27);

                Map map27 = new HashMap();
                map27.put("customfieldName", "项目成员");
                map27.put("value", listValue27);


                //完成日期 （合同要求）
                Map mapValue28 = new HashMap();
                mapValue28.put("id", "");
                mapValue28.put("title", wanchengTime);

                List listValue28 = new ArrayList();
                listValue28.add(mapValue28);

                Map map28 = new HashMap();
                map28.put("customfieldName", "完成日期 （合同要求）");
                map28.put("value", listValue28);

                //质保月数
                Map mapValue29 = new HashMap();
                mapValue29.put("id", "");
                mapValue29.put("title", zhibaoyueshu);

                List listValue29 = new ArrayList();
                listValue29.add(mapValue29);

                Map map29 = new HashMap();
                map29.put("customfieldName", "质保月数");
                map29.put("value", listValue29);

                //合同推进状态
                Map mapValue30 = new HashMap();
                mapValue30.put("id", "");
                mapValue30.put("title", "已完成");
                //【说明：针对合同交底表单提交的单据，该字段默认传“已完成”；预投入交底表单传表单对应的控件值】

                List listValue30 = new ArrayList();
                listValue30.add(mapValue30);

                Map map30 = new HashMap();
                map30.put("customfieldName", "合同推进状态");
                map30.put("value", listValue30);

                //售前人员
                Map mapValue31 = new HashMap();
                mapValue31.put("id", "");
                mapValue31.put("title", userNameShouqianrenyuan);

                List listValue31 = new ArrayList();
                listValue31.add(mapValue31);

                Map map31 = new HashMap();
                map31.put("customfieldName", "售前人员");
                map31.put("value", listValue31);

                listAll.add(map1);
                listAll.add(map2);
                listAll.add(map3);
                listAll.add(map4);
                listAll.add(map5);
                listAll.add(map6);
                listAll.add(map7);
                listAll.add(map8);
                listAll.add(map9);
                listAll.add(map11);
                listAll.add(map12);
                listAll.add(map13);
                listAll.add(map14);
                listAll.add(map15);
                listAll.add(map16);
                listAll.add(map17);
                listAll.add(map18);
                listAll.add(map19);
                listAll.add(map20);
                listAll.add(map21);
                listAll.add(map22);
                listAll.add(map23);
                listAll.add(map24);
                listAll.add(map25);
                listAll.add(map26);
                listAll.add(map27);
                listAll.add(map28);
                listAll.add(map29);
                listAll.add(map30);
                listAll.add(map31);


                /*
                 * 总看板项目ID
                 *
                 * 交付总看板（软件类）：63c4ea646ff268bcab3f82b3
                 * 交付总看板（咨询）：63c64671432c0b7bbba01c48
                 * 交付总看板（运维）：63c64924df32b699b98cf049
                 *
                 * */

                log.info("开始执行创建任务到对应的总看板...");
                //总看板项目id
                String ZongkanbanId = null;
                //拥有者id
                String yongyouzhe = null;
                //判断项目类型对应的TB对应的总看板项目ID
                if (xiangmuleixing.equals("实施型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("二开型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("开发型项目")) {

                    ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("完整型咨询项目")) {

                    ZongkanbanId = "63c64671432c0b7bbba01c48";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("简易型咨询项目")) {

                    ZongkanbanId = "63c64671432c0b7bbba01c48";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                } else if (xiangmuleixing.equals("运维项目")) {

                    ZongkanbanId = "63c64924df32b699b98cf049";
                    yongyouzhe = getYongyouzhe(ZongkanbanId);

                }
                createTask(ZongkanbanId, yongyouzhe, xiangmumingcheng, tBuserIdJingli, list, startTime, stopTime, listAll);


                /*创建任务到对应的总看板*/

                /*
                 * 项目概览自定义字段名称：
                 * 产品分类
                 * 是否新业态
                 * 产品线
                 * 业务归属
                 * 区域
                 * 实施牵头主体
                 * 项目类型
                 * 项目等级
                 * 客户名称
                 * 客户类型
                 * 客户等级
                 * 所属省
                 * 所属市区
                 * 所属区县
                 * 项目经理
                 * 销售人员
                 * 项目成员
                 *
                 * */

                /*更新项目概览字段*/
                log.info("开始执行多次更新项目概览字段...");
                //产品分类
                log.info("开始更新写入【产品分类】");
                updateCustomfieldId(xiangmuId, tBuserId, chanpinfenlei, "产品分类");
                //是否新业态
                log.info("开始更新写入【是否新业态】");
                updateCustomfieldId(xiangmuId, tBuserId, shifouxinyetai, "是否新业态");
                //产品线
                log.info("开始更新写入【产品线】");
                updateCustomfieldId(xiangmuId, tBuserId, chanpinxian, "产品线");
                //业务归属
                log.info("开始更新写入【业务归属】");
                updateCustomfieldId(xiangmuId, tBuserId, yewuguishu, "业务归属");
                //区域
                log.info("开始更新写入【区域】");
                updateCustomfieldId(xiangmuId, tBuserId, quyu, "区域");
                //实施牵头主体
                log.info("开始更新写入【实施牵头主体】");
                updateCustomfieldId(xiangmuId, tBuserId, shishizhuti, "实施牵头主体");
                //项目类型
                log.info("开始更新写入【项目类型】");
                updateCustomfieldId(xiangmuId, tBuserId, xiangmuleixing, "项目类型");
                //项目等级
                log.info("开始更新写入【项目等级】");
                updateCustomfieldId(xiangmuId, tBuserId, xiangmudengji, "项目等级");
                //客户名称
                log.info("开始更新写入【客户名称】");
                updateCustomfieldId(xiangmuId, tBuserId, kehumingcheng, "客户名称");
                //客户类型
                log.info("开始更新写入【客户名称】");
                updateCustomfieldId(xiangmuId, tBuserId, kehuleixing, "客户类型");
                //客户等级
                log.info("开始更新写入【客户等级】");
                updateCustomfieldId(xiangmuId, tBuserId, kehudengji, "客户等级");
                //所属省
                log.info("开始更新写入【所属省】");
                updateCustomfieldId(xiangmuId, tBuserId, suoshusheng, "所属省");
                //所属市区
                log.info("开始更新写入【所属市区】");
                updateCustomfieldId(xiangmuId, tBuserId, suoshushiqu, "所属市区");
                //所属区县
                log.info("开始更新写入【所属区县】");
                updateCustomfieldId(xiangmuId, tBuserId, suoshuquxian, "所属区县");
                //项目经理
                log.info("开始更新写入【项目经理】");
                updateCustomfieldId(xiangmuId, tBuserId, userNameJingli, "项目经理");
                //销售人员
                log.info("开始更新写入【销售人员】");
                updateCustomfieldId(xiangmuId, tBuserId, xiaoshourenyuanName, "销售人员");
                //项目成员
                log.info("开始更新写入【项目成员】");
                updateCustomfieldId(xiangmuId, tBuserId, xiangmuchengyuanName, "项目成员");


                //合同编号
                log.info("开始更新写入【合同编号】");
                updateCustomfieldId(xiangmuId, tBuserId, hetongbianhao, "合同编号");
                //售前人员
                log.info("开始更新写入【售前人员】");
                updateCustomfieldId(xiangmuId, tBuserId, userNameShouqianrenyuan, "售前人员");
                //是否为代理项目
                log.info("开始更新写入【是否为代理项目】");
                updateCustomfieldId(xiangmuId, tBuserId, shifouweidailixiangmu, "是否为代理项目");
                //渠道（代理）名称
                log.info("开始更新写入【渠道（代理）名称】");
                updateCustomfieldId(xiangmuId, tBuserId, qudaodailimingcheng, "渠道（代理）名称");


                return "根据模板创建TB项目完成（合同交底）！";
            }
        }else if (DJLX.equals("预投入交底")){
            log.info("===开始进入【预投入交底】创建===");

            /*
             * 模板定义（ID）
             *
             * 交付中心（二开型项目模板）：63fd678ccab2960018ddb394
             * 交付中心（简易型咨询项目模板）：63fd67c7806fae0017a8800f
             * 交付中心（实施型项目模板）：63fd67eaba9b960018ff8b12
             * 交付中心（完整型咨询项目模板）：63fd680cdf94010017d80712
             * 交付中心（研发型项目模板）：63fd682b72396e00186d9287
             * 交付中心（运维型项目模板）：63fd687140558f0018105345
             *
             * 教育项目模版：63e065d0fe8217001780785f
             * 教育事业部项目-模板项目：63fda913ed5a640018eac515
             * 教育事业部-咨询项目模板：640aa043b36b11001849dff4
             * 教育事业部-研发型任务模板：640e84795ab52c0017e508ea
             *
             * 交付总看板（软件类） 模板：640ebb5effa4d40018ea5cc5
             * 交付总看板（运维） 模板：640ebb8f3e07ec00187d9c58
             * 交付总看板（咨询）模板：640ebbe0c8335700184485de
             *
             * 平台事业部项目模板-课程培训项目：64269ad55135aeb5c9786131
             * */


            //模板ID
            String TemplateId = null;

            //判断项目类型对应的TB项目模板ID
            if (xiangmuleixing.equals("实施型项目")) {

                TemplateId = "63fd67eaba9b960018ff8b12";

            } else if (xiangmuleixing.equals("二开型项目")) {

                TemplateId = "63fd678ccab2960018ddb394";

            } else if (xiangmuleixing.equals("开发型项目")) {

                TemplateId = "63fd682b72396e00186d9287";

            } else if (xiangmuleixing.equals("完整型咨询项目")) {

                TemplateId = "63fd680cdf94010017d80712";

            } else if (xiangmuleixing.equals("简易型咨询项目")) {

                TemplateId = "63fd67c7806fae0017a8800f";

            } else if (xiangmuleixing.equals("运维项目")) {

                TemplateId = "63fd687140558f0018105345";

            } else if (xiangmuleixing.equals("教育软件项目")) {
                TemplateId = "63fda913ed5a640018eac515";
            } else if (xiangmuleixing.equals("课程培训项目")) {
                TemplateId = "64269ad55135aeb5c9786131";
            } else if (xiangmuleixing.equals("内部产品研发项目")) {
                TemplateId = "63fc661c6ac87b00175c5c3d";
            }

            /*一、根据模板创建TB项目*/
            log.info("开始执行根据模板创建TB项目...");
            JSONObject jsonObject = null;
            try {
                com.aliyun.dingtalkproject_1_0.Client client = createClient();
                com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders createProjectByTemplateHeaders = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders();
                createProjectByTemplateHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest createProjectByTemplateRequest = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest()
                        //项目名称
                        .setName(xiangmumingcheng)
                        //模板ID
                        .setTemplateId(TemplateId);

                //操作人员userId（目前统一默认【郑晓峰61dd45cc5eeb5025ebd13ff1】为项目创建人）
                CreateProjectByTemplateResponse projectByTemplateWithOptions = client.createProjectByTemplateWithOptions("014420484336462990", createProjectByTemplateRequest, createProjectByTemplateHeaders, new RuntimeOptions());
                String s = JSON.toJSONString(projectByTemplateWithOptions.getBody());
                jsonObject = JSON.parseObject(s);
                System.out.println("【创建项目】接口object对象：" + jsonObject);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }
            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }
            }
            String xiangmuId = jsonObject.getJSONObject("result").getString("id");
            System.out.println("【创建项目】接口object对象返回的【项目ID】：" + xiangmuId);


            /*三、根据项目ID更新项目成员*/
            log.info("开始执行根据项目ID更新项目成员...");
            JSONObject jsonObject1 = null;
            try {
                com.aliyun.dingtalkproject_1_0.Client client = createClient();
                com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders addProjectMemberHeaders = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberHeaders();
                addProjectMemberHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest addProjectMemberRequest = new com.aliyun.dingtalkproject_1_0.models.AddProjectMemberRequest()
                        //项目成员userId列表
                        .setUserIds(asList);

                //参数一：操作人员userId；
                //参数二：项目ID
                AddProjectMemberResponse addProjectMemberResponse = client.addProjectMemberWithOptions("014420484336462990", xiangmuId, addProjectMemberRequest, addProjectMemberHeaders, new RuntimeOptions());
                String s = JSON.toJSONString(addProjectMemberResponse.getBody());
                jsonObject1 = JSON.parseObject(s);
                System.out.println("【更新项目成员】接口object对象：" + jsonObject1);
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }
            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }
            }

            /*根据宜搭项目经理人员userid匹配获取TB人员ID*/
            log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
            String tBuserIdJingli = getTBuserId(userStrJingli);

            /*四、根据项目ID更新项目经理角色*/
            log.info("开始执行根据项目ID获取项目经理角色ID...");
            String jueseID = getJueseID(xiangmuId);
            log.info("开始执行根据项目ID更新项目经理角色...");
            updateJuese(xiangmuId, tBuserIdJingli, jueseID);


            /*根据宜搭人员userid匹配获取TB人员ID*/
            log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");
            String tBuserId = getTBuserId(userStr);

            /*更新项目分组文件夹*/
            log.info("开始执行更新项目分组文件夹...");
            updateProjectTag(tBuserId, xiangmuId, xiangmuleixing, yewuguishu);


            /*创建任务到对应的总看板*/
            /*
             * 总看板项目ID
             *
             * 交付总看板（软件类）：63c4ea646ff268bcab3f82b3
             * 交付总看板（咨询）：63c64671432c0b7bbba01c48
             * 交付总看板（运维）：63c64924df32b699b98cf049
             *
             * */


            /*根据宜搭项目参与人员useridList匹配获取多个TB人员ID*/
            log.info("开始执行根据宜搭人员userid匹配获取TB人员ID...");



            List listAll = new ArrayList();
            //产品分类
//            Map mapValue1 = new HashMap();
//            mapValue1.put("id", "");
//            mapValue1.put("title", chanpinfenlei);
//
//            List listValue1 = new ArrayList();
//            listValue1.add(mapValue1);
//
//            Map map1 = new HashMap();
//            map1.put("customfieldName", "产品分类");
//            map1.put("value", listValue1);
            //是否新业态
            Map mapValue2 = new HashMap();
            mapValue2.put("id", "");
            mapValue2.put("title", shifouxinyetai);

            List listValue2 = new ArrayList();
            listValue2.add(mapValue2);

            Map map2 = new HashMap();
            map2.put("customfieldName", "是否新业态");
            map2.put("value", listValue2);
            //产品线
            Map mapValue3 = new HashMap();
            mapValue3.put("id", "");
            mapValue3.put("title", chanpinxian);

            List listValue3 = new ArrayList();
            listValue3.add(mapValue3);

            Map map3 = new HashMap();
            map3.put("customfieldName", "产品线");
            map3.put("value", listValue3);
            //业务归属
            Map mapValue4 = new HashMap();
            mapValue4.put("id", "");
            mapValue4.put("title", yewuguishu);

            List listValue4 = new ArrayList();
            listValue4.add(mapValue4);

            Map map4 = new HashMap();
            map4.put("customfieldName", "业务归属");
            map4.put("value", listValue4);
            //区域
            Map mapValue5 = new HashMap();
            mapValue5.put("id", "");
            mapValue5.put("title", quyu);

            List listValue5 = new ArrayList();
            listValue5.add(mapValue5);

            Map map5 = new HashMap();
            map5.put("customfieldName", "区域");
            map5.put("value", listValue5);
            //实施牵头主体
            Map mapValue6 = new HashMap();
            mapValue6.put("id", "");
            mapValue6.put("title", shishizhuti);

            List listValue6 = new ArrayList();
            listValue6.add(mapValue6);

            Map map6 = new HashMap();
            map6.put("customfieldName", "实施牵头主体");
            map6.put("value", listValue6);
            //合同归属
//            Map mapValue7 = new HashMap();
//            mapValue7.put("id", "");
//            mapValue7.put("title", hetongguishu);
//
//            List listValue7 = new ArrayList();
//            listValue7.add(mapValue7);
//
//            Map map7 = new HashMap();
//            map7.put("customfieldName", "合同归属");
//            map7.put("value", listValue7);
            //销售类型
            Map mapValue8 = new HashMap();
            mapValue8.put("id", "");
            mapValue8.put("title", xiaoshouleixing);

            List listValue8 = new ArrayList();
            listValue8.add(mapValue8);

            Map map8 = new HashMap();
            map8.put("customfieldName", "销售类型");
            map8.put("value", listValue8);
            //合同编号
//            Map mapValue9 = new HashMap();
//            mapValue9.put("id", "");
//            mapValue9.put("title", hetongbianhao);
//
//            List listValue9 = new ArrayList();
//            listValue9.add(mapValue9);
//
//            Map map9 = new HashMap();
//            map9.put("customfieldName", "合同编号");
//            map9.put("value", listValue9);
//        //合同分类
//        Map mapValue10 = new HashMap();
//        mapValue10.put("id","");
//        mapValue10.put("title",);
            //项目类型
            Map mapValue11 = new HashMap();
            mapValue11.put("id", "");
            mapValue11.put("title", xiangmuleixing);

            List listValue11 = new ArrayList();
            listValue11.add(mapValue11);

            Map map11 = new HashMap();
            map11.put("customfieldName", "项目类型");
            map11.put("value", listValue11);
            //项目名称
            Map mapValue12 = new HashMap();
            mapValue12.put("id", "");
            mapValue12.put("title", xiangmumingcheng);

            List listValue12 = new ArrayList();
            listValue12.add(mapValue12);

            Map map12 = new HashMap();
            map12.put("customfieldName", "项目名称");
            map12.put("value", listValue12);
            //项目等级
//            Map mapValue13 = new HashMap();
//            mapValue13.put("id", "");
//            mapValue13.put("title", xiangmudengji);
//
//            List listValue13 = new ArrayList();
//            listValue13.add(mapValue13);
//
//            Map map13 = new HashMap();
//            map13.put("customfieldName", "项目等级");
//            map13.put("value", listValue13);
            //客户名称
            Map mapValue14 = new HashMap();
            mapValue14.put("id", "");
            mapValue14.put("title", kehumingcheng);

            List listValue14 = new ArrayList();
            listValue14.add(mapValue14);

            Map map14 = new HashMap();
            map14.put("customfieldName", "客户名称");
            map14.put("value", listValue14);
            //客户类型
//            Map mapValue15 = new HashMap();
//            mapValue15.put("id", "");
//            mapValue15.put("title", kehuleixing);
//
//            List listValue15 = new ArrayList();
//            listValue15.add(mapValue15);
//
//            Map map15 = new HashMap();
//            map15.put("customfieldName", "客户类型");
//            map15.put("value", listValue15);
            //客户等级
            Map mapValue16 = new HashMap();
            mapValue16.put("id", "");
            mapValue16.put("title", kehudengji);

            List listValue16 = new ArrayList();
            listValue16.add(mapValue16);

            Map map16 = new HashMap();
            map16.put("customfieldName", "客户等级");
            map16.put("value", listValue16);
            //所属省
            Map mapValue17 = new HashMap();
            mapValue17.put("id", "");
            mapValue17.put("title", suoshusheng);

            List listValue17 = new ArrayList();
            listValue17.add(mapValue17);

            Map map17 = new HashMap();
            map17.put("customfieldName", "所属省");
            map17.put("value", listValue17);
            //所属市区
            Map mapValue18 = new HashMap();
            mapValue18.put("id", "");
            mapValue18.put("title", suoshushiqu);

            List listValue18 = new ArrayList();
            listValue18.add(mapValue18);

            Map map18 = new HashMap();
            map18.put("customfieldName", "所属市区");
            map18.put("value", listValue18);
            //所属区县
            Map mapValue19 = new HashMap();
            mapValue19.put("id", "");
            mapValue19.put("title", suoshuquxian);

            List listValue19 = new ArrayList();
            listValue19.add(mapValue19);

            Map map19 = new HashMap();
            map19.put("customfieldName", "所属区县");
            map19.put("value", listValue19);
            //是否为代理项目
            Map mapValue20 = new HashMap();
            mapValue20.put("id", "");
            mapValue20.put("title", shifouweidailixiangmu);

            List listValue20 = new ArrayList();
            listValue20.add(mapValue20);

            Map map20 = new HashMap();
            map20.put("customfieldName", "是否为代理项目");
            map20.put("value", listValue20);
            //渠道（代理）名称
            Map mapValue21 = new HashMap();
            mapValue21.put("id", "");
            mapValue21.put("title", qudaodailimingcheng);

            List listValue21 = new ArrayList();
            listValue21.add(mapValue21);

            Map map21 = new HashMap();
            map21.put("customfieldName", "渠道（代理）名称");
            map21.put("value", listValue21);
            //销售人员
            Map mapValue22 = new HashMap();
            mapValue22.put("id", "");
            mapValue22.put("title", xiaoshourenyuanName);

            List listValue22 = new ArrayList();
            listValue22.add(mapValue22);

            Map map22 = new HashMap();
            map22.put("customfieldName", "销售人员");
            map22.put("value", listValue22);
            //运维负责人
//            Map mapValue23 = new HashMap();
//            mapValue23.put("id", "");
//            mapValue23.put("title", userNameYunweifuzeren);
//
//            List listValue23 = new ArrayList();
//            listValue23.add(mapValue23);
//
//            Map map23 = new HashMap();
//            map23.put("customfieldName", "运维负责人");
//            map23.put("value", listValue23);
            //运维月数
//            Map mapValue24 = new HashMap();
//            mapValue24.put("id", "");
//            mapValue24.put("title", yunweiyueshu);
//
//            List listValue24 = new ArrayList();
//            listValue24.add(mapValue24);
//
//            Map map24 = new HashMap();
//            map24.put("customfieldName", "运维月数");
//            map24.put("value", listValue24);
            //合同金额 （元）
//            Map mapValue25 = new HashMap();
//            mapValue25.put("id", "");
//            mapValue25.put("title", hetongjine);
//
//            List listValue25 = new ArrayList();
//            listValue25.add(mapValue25);
//
//            Map map25 = new HashMap();
//            map25.put("customfieldName", "合同金额 （元）");
//            map25.put("value", listValue25);
            //项目经理
            Map mapValue26 = new HashMap();
            mapValue26.put("id", "");
            mapValue26.put("title", userNameJingli);

            List listValue26 = new ArrayList();
            listValue26.add(mapValue26);

            Map map26 = new HashMap();
            map26.put("customfieldName", "项目经理");
            map26.put("value", listValue26);
            //项目成员
            Map mapValue27 = new HashMap();
            mapValue27.put("id", "");
            mapValue27.put("title", xiangmuchengyuanName);

            List listValue27 = new ArrayList();
            listValue27.add(mapValue27);

            Map map27 = new HashMap();
            map27.put("customfieldName", "项目成员");
            map27.put("value", listValue27);


            //完成日期 （合同要求）
//            Map mapValue28 = new HashMap();
//            mapValue28.put("id", "");
//            mapValue28.put("title", wanchengTime);
//
//            List listValue28 = new ArrayList();
//            listValue28.add(mapValue28);
//
//            Map map28 = new HashMap();
//            map28.put("customfieldName", "完成日期 （合同要求）");
//            map28.put("value", listValue28);

            //质保月数
//            Map mapValue29 = new HashMap();
//            mapValue29.put("id", "");
//            mapValue29.put("title", zhibaoyueshu);
//
//            List listValue29 = new ArrayList();
//            listValue29.add(mapValue29);
//
//            Map map29 = new HashMap();
//            map29.put("customfieldName", "质保月数");
//            map29.put("value", listValue29);

            //合同推进状态
            Map mapValue30 = new HashMap();
            mapValue30.put("id", "");
            mapValue30.put("title", hetongtuijinzhuangtai);
            //【说明：针对合同交底表单提交的单据，该字段默认传“已完成”；预投入交底表单传表单对应的控件值】

            List listValue30 = new ArrayList();
            listValue30.add(mapValue30);

            Map map30 = new HashMap();
            map30.put("customfieldName", "合同推进状态");
            map30.put("value", listValue30);

            //售前人员
            Map mapValue31 = new HashMap();
            mapValue31.put("id", "");
            mapValue31.put("title", userNameShouqianrenyuan);

            List listValue31 = new ArrayList();
            listValue31.add(mapValue31);

            Map map31 = new HashMap();
            map31.put("customfieldName", "售前人员");
            map31.put("value", listValue31);

//            listAll.add(map1);
            listAll.add(map2);
            listAll.add(map3);
            listAll.add(map4);
            listAll.add(map5);
            listAll.add(map6);
//            listAll.add(map7);
            listAll.add(map8);
//            listAll.add(map9);
            listAll.add(map11);
            listAll.add(map12);
//            listAll.add(map13);
            listAll.add(map14);
//            listAll.add(map15);
            listAll.add(map16);
            listAll.add(map17);
            listAll.add(map18);
            listAll.add(map19);
            listAll.add(map20);
            listAll.add(map21);
            listAll.add(map22);
//            listAll.add(map23);
//            listAll.add(map24);
//            listAll.add(map25);
            listAll.add(map26);
            listAll.add(map27);
//            listAll.add(map28);
//            listAll.add(map29);
            listAll.add(map30);
            listAll.add(map31);


            /*
             * 总看板项目ID
             *
             * 交付总看板（软件类）：63c4ea646ff268bcab3f82b3
             * 交付总看板（咨询）：63c64671432c0b7bbba01c48
             * 交付总看板（运维）：63c64924df32b699b98cf049
             *
             * */

            log.info("开始执行创建任务到对应的总看板...");
            //总看板项目id
            String ZongkanbanId = null;
            //拥有者id
            String yongyouzhe = null;
            //判断项目类型对应的TB对应的总看板项目ID
            if (xiangmuleixing.equals("实施型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("二开型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("开发型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("完整型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("简易型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("运维项目")) {

                ZongkanbanId = "63c64924df32b699b98cf049";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            }
            createTask(ZongkanbanId, yongyouzhe, xiangmumingcheng, tBuserIdJingli, list, startTime, stopTime, listAll);


            /*创建任务到对应的总看板*/

            /*
             * 项目概览自定义字段名称：
             * 产品分类
             * 是否新业态
             * 产品线
             * 业务归属
             * 区域
             * 实施牵头主体
             * 项目类型
             * 项目等级
             * 客户名称
             * 客户类型
             * 客户等级
             * 所属省
             * 所属市区
             * 所属区县
             * 项目经理
             * 销售人员
             * 项目成员
             *
             * */

            /*更新项目概览字段*/
            log.info("开始执行多次更新项目概览字段...");
            //产品分类
//            log.info("开始更新写入【产品分类】");
//            updateCustomfieldId(xiangmuId, tBuserId, chanpinfenlei, "产品分类");
            //是否新业态
            log.info("开始更新写入【是否新业态】");
            updateCustomfieldId(xiangmuId, tBuserId, shifouxinyetai, "是否新业态");
            //产品线
            log.info("开始更新写入【产品线】");
            updateCustomfieldId(xiangmuId, tBuserId, chanpinxian, "产品线");
            //业务归属
            log.info("开始更新写入【业务归属】");
            updateCustomfieldId(xiangmuId, tBuserId, yewuguishu, "业务归属");
            //区域
            log.info("开始更新写入【区域】");
            updateCustomfieldId(xiangmuId, tBuserId, quyu, "区域");
            //实施牵头主体
            log.info("开始更新写入【实施牵头主体】");
            updateCustomfieldId(xiangmuId, tBuserId, shishizhuti, "实施牵头主体");
            //项目类型
            log.info("开始更新写入【项目类型】");
            updateCustomfieldId(xiangmuId, tBuserId, xiangmuleixing, "项目类型");
            //项目等级
//            log.info("开始更新写入【项目等级】");
//            updateCustomfieldId(xiangmuId, tBuserId, xiangmudengji, "项目等级");
            //客户名称
            log.info("开始更新写入【客户名称】");
            updateCustomfieldId(xiangmuId, tBuserId, kehumingcheng, "客户名称");
            //客户类型
//            log.info("开始更新写入【客户名称】");
//            updateCustomfieldId(xiangmuId, tBuserId, kehuleixing, "客户类型");
            //客户等级
            log.info("开始更新写入【客户等级】");
            updateCustomfieldId(xiangmuId, tBuserId, kehudengji, "客户等级");
            //所属省
            log.info("开始更新写入【所属省】");
            updateCustomfieldId(xiangmuId, tBuserId, suoshusheng, "所属省");
            //所属市区
            log.info("开始更新写入【所属市区】");
            updateCustomfieldId(xiangmuId, tBuserId, suoshushiqu, "所属市区");
            //所属区县
            log.info("开始更新写入【所属区县】");
            updateCustomfieldId(xiangmuId, tBuserId, suoshuquxian, "所属区县");
            //项目经理
            log.info("开始更新写入【项目经理】");
            updateCustomfieldId(xiangmuId, tBuserId, userNameJingli, "项目经理");
            //销售人员
            log.info("开始更新写入【销售人员】");
            updateCustomfieldId(xiangmuId, tBuserId, xiaoshourenyuanName, "销售人员");
            //项目成员
            log.info("开始更新写入【项目成员】");
            updateCustomfieldId(xiangmuId, tBuserId, xiangmuchengyuanName, "项目成员");


            //合同编号
//            log.info("开始更新写入【合同编号】");
//            updateCustomfieldId(xiangmuId, tBuserId, hetongbianhao, "合同编号");
            //售前人员
            log.info("开始更新写入【售前人员】");
            updateCustomfieldId(xiangmuId, tBuserId, userNameShouqianrenyuan, "售前人员");
            //是否为代理项目
            log.info("开始更新写入【是否为代理项目】");
            updateCustomfieldId(xiangmuId, tBuserId, shifouweidailixiangmu, "是否为代理项目");
            //渠道（代理）名称
            log.info("开始更新写入【渠道（代理）名称】");
            updateCustomfieldId(xiangmuId, tBuserId, qudaodailimingcheng, "渠道（代理）名称");

            return "根据模板创建TB项目完成（预投入交底）！";
        }
        else if (DJLX.equals("开票申请")){
            log.info("===开始进入【开票申请】更新===");

            //已存在的项目id
            String xmid = xiangmuResult.getJSONObject(0).getString("id");
            System.out.println("已存在的项目id：" + xmid);

            /*获取项目拥有者（TB人员id）*/
            String yongyouzhe1 = getYongyouzhe(xmid);


            /*更新项目概览字段*/
            log.info("开始执行多次更新项目概览字段...");
            //开票金额
//            log.info("开始更新写入【开票金额】");
//            updateCustomfieldId(xmid, yongyouzhe1, kaipiaojine, "开票金额 （元）");


            //获取总看板下该项目名称的任务ID
            //总看板项目id
            String ZongkanbanId = null;
            //拥有者id
            String yongyouzhe = null;
            //判断项目类型对应的TB对应的总看板项目ID
            if (xiangmuleixing.equals("实施型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("二开型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("开发型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("完整型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("简易型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("运维项目")) {

                ZongkanbanId = "63c64924df32b699b98cf049";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            }
//                else if (xiangmuleixing.equals("教育软件项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("课程培训项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("内部产品研发项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                }

            //任务ID
            String renwuId = getRenwuId(ZongkanbanId, xiangmumingcheng);


            /*更新总看板任务自定义字段*/
            //开票比例
            updateRenwuzidingyiziduan(yongyouzhe,renwuId,kaipiaobili,"开票比例");
            //开票金额
            updateRenwuzidingyiziduan(yongyouzhe,renwuId,kaipiaojine,"开票金额 （元）");



            System.out.println("更新TB已存在项目信息完成（开票申请）！");

            return "根据项目名称更新TB项目的开票金额！";
        }else if (DJLX.equals("回款")){
            log.info("===开始进入【回款】更新===");

            //已存在的项目id
            String xmid = xiangmuResult.getJSONObject(0).getString("id");
            System.out.println("已存在的项目id：" + xmid);

            /*获取项目拥有者（TB人员id）*/
            String yongyouzhe1 = getYongyouzhe(xmid);


            /*更新项目概览字段*/
            log.info("开始执行多次更新项目概览字段...");
            //开票金额
//            log.info("开始更新写入【开票金额】");
//            updateCustomfieldId(xmid, yongyouzhe1, huikuanjine, "回款金额 （元）");


            //获取总看板下该项目名称的任务ID
            //总看板项目id
            String ZongkanbanId = null;
            //拥有者id
            String yongyouzhe = null;
            //判断项目类型对应的TB对应的总看板项目ID
            if (xiangmuleixing.equals("实施型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("二开型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("开发型项目")) {

                ZongkanbanId = "63c4ea646ff268bcab3f82b3";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("完整型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("简易型咨询项目")) {

                ZongkanbanId = "63c64671432c0b7bbba01c48";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            } else if (xiangmuleixing.equals("运维项目")) {

                ZongkanbanId = "63c64924df32b699b98cf049";
                yongyouzhe = getYongyouzhe(ZongkanbanId);

            }
//                else if (xiangmuleixing.equals("教育软件项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("课程培训项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                } else if (xiangmuleixing.equals("内部产品研发项目")) {
//
//                    ZongkanbanId = "63c64924df32b699b98cf049";
//                    yongyouzhe = getYongyouzhe(ZongkanbanId);
//
//                }

            //任务ID
            String renwuId = getRenwuId(ZongkanbanId, xiangmumingcheng);


            /*更新总看板任务自定义字段*/
            //回款比例
            updateRenwuzidingyiziduan(yongyouzhe,renwuId,huikuanbili,"回款比例");
            //回款金额
            updateRenwuzidingyiziduan(yongyouzhe,renwuId,huikuanjine,"回款金额 （元）");



            System.out.println("更新TB已存在项目信息完成（回款）！");


            return "根据项目名称更新TB项目的回款金额！";
        }
        else {
            log.info("===开始进入【其他情况】创建===");



            return "【暂无】其他表单！";
        }
    }
}
