package com.muzhi.tb.APITest;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateResponse;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceHeaders;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceRequest;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.auth0.jwt.JWT;
import com.auth0.jwt.algorithms.Algorithm;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiV2UserGetbymobileRequest;
import com.dingtalk.api.response.OapiV2UserGetbymobileResponse;
import com.muzhi.tb.service.AccessTokenService;
import com.muzhi.tb.service.impl.TbServiceImpl;
import com.taobao.api.ApiException;
import okhttp3.*;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

@SpringBootTest
public class Test2 {

    @Autowired
    private AccessTokenService accessTokenService;

    public static String result = null;

    public static final Long   EXPIRES_IN = 1 * 3600 * 1000L;
    public static final String TOKEN_APPID = "_appId";

    //企业ID：5ca44db8ca4fd40001b10559
    public static final String appId = "63218a98d4b83fe98c507a47";
    public static final String appSecret = "xbp4kN6j4FBKPsJAdEX9Gd2cJMeuyP4Y";

    @Test
    public void tb(){

        //1、将TB的userid放在数组中
        String userId = "5f3a250040ce230ba377bf3c";
        List list = new ArrayList();
        list.add(userId);
        System.out.println("list：" + list);
        //2、将TB接口指定传入的body请求体封装成集合
        Map map = new HashMap();
        map.put("orgId","5ca44db8ca4fd40001b10559");
        map.put("userIds",list);
        String userBody = JSON.toJSONString(map);
        System.out.println("userBody：" + userBody);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        //传入上面封装好的userBody请求体
        RequestBody body = RequestBody
                .create(mediaType, userBody);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/org/member/batchGet")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                //TB应用授权码
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", "5ca44db8ca4fd40001b10559")
                //租户类型，默认为 organization
                .addHeader("X-Tenant-Type", "organization")
                .build();

        String name = null;
        String phone = null;
        try {
            Response response = client.newCall(request).execute();
            result = response.body().string();
            JSONObject jsonObject = JSON.parseObject(result);
            System.out.println("返回结果result：" + jsonObject);

            JSONArray result = jsonObject.getJSONArray("result");
            System.out.println("解析数组result：" + result);
            name = result.getJSONObject(0).getString("name");
            System.out.println("提取name：" + name);
            String phone1 = result.getJSONObject(0).getString("phone");
            phone = phone1.substring(3);
            System.out.println("提取phone：" + phone);
        }catch (IOException e){
            e.printStackTrace();
        }

        //【钉钉：根据手机号查询用户】
        String dingUserId = null;
        try {
            DingTalkClient client1 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/user/getbymobile");
            OapiV2UserGetbymobileRequest req = new OapiV2UserGetbymobileRequest();
            req.setMobile(phone);
            OapiV2UserGetbymobileResponse rsp = client1.execute(req, accessTokenService.getAccessToken());
            System.out.println(rsp.getBody());
            dingUserId = JSON.parseObject(rsp.getBody()).getJSONObject("result").getString("userid");
            System.out.println("钉钉userid（和宜搭一致）：" + dingUserId);
        } catch (ApiException e) {
            e.printStackTrace();
        }
    }

    /**
     * 使用 Token 初始化账号Client
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    @Test
    public void tbTOyida() throws Exception{
        String created = "2022-09-21T08:51:29.669Z";

        created = created.replace("Z", " UTC");
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS Z");
        SimpleDateFormat defaultFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateTime = "";
        long time1 = 0;
        try {
            Date time = format.parse(created);
            dateTime = defaultFormat.format(time);
            System.out.println("dateTime：" + dateTime);
            time1 = time.getTime();
            System.out.println("时间戳：" + time1);
        } catch (Exception e) {
            e.printStackTrace();
        }

        Map map = new HashMap();
        map.put("textField_l88d4swp", "111222333");
        map.put("textField_l82qfm9t", "这是一个测试项目");
        map.put("employeeField_l82qfm9u", "15973727592422668");
        map.put("dateField_l82qfm9y", time1);
        String mapJson = JSON.toJSONString(map);

        //参数args默认传值，无固定值，传固定值也可。
//        String[] args_ = {"123"};
//        java.util.List<String> args = java.util.Arrays.asList(args_);
        com.aliyun.dingtalkyida_1_0.Client client = createClient();
        com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders saveFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders();
        //钉钉token授权码
        saveFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
        com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest saveFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest()
                //宜搭应用秘钥（宜搭使用的是钉钉token授权码）
                .setSystemToken("WP966ZB1A4S3UPKK874E098BVPXN2EHYMP28LZE")
                //宜搭表单ID（项目管理表单）
                .setFormUuid("FORM-OS566L91S9Y3NHB9CFHMU6HZEQAJ22C6NP28L4")
                //TODO 发起人：用户useId
                .setUserId("15973727592422668")
                //宜搭应用编码
                .setAppType("APP_NOQGHDKUDXD7VDWZUC6I")
                //TODO 宜搭表单控件传参：json格式，同时对应表单的控件id进行传值创建表单数据
                .setFormDataJson(mapJson);
        try {
            client.saveFormDataWithOptions(saveFormDataRequest, saveFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
    }

    @Test
    public void createYiDaRW() throws Exception{

        String created = "2022-09-21T08:51:29.669Z";

        created = created.replace("Z", " UTC");
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS Z");
        SimpleDateFormat defaultFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String dateTime = "";
        long time1 = 0;
        try {
            Date time = format.parse(created);
            dateTime = defaultFormat.format(time);
            System.out.println("dateTime：" + dateTime);
            time1 = time.getTime();
            System.out.println("时间戳：" + time1);
        } catch (Exception e) {
            e.printStackTrace();
        }

        //======任务表单中的项目关联表单控件值======
        Map xmMap = new HashMap();
        //表单类型：默认
        xmMap.put("formType","receipt");
        //项目表单ID
        xmMap.put("formUuid","FORM-OS566L91S9Y3NHB9CFHMU6HZEQAJ22C6NP28L4");
        //项目表单实例ID
        xmMap.put("instanceId","FINST-J0A66981JGX305I3BFO1N6MSB8552E402848LUL5");
        //标题
        xmMap.put("subTitle","张侃");
        //应用编码appType
        xmMap.put("appType","APP_NOQGHDKUDXD7VDWZUC6I");
        //表单实例标题
        xmMap.put("title","测试项目");
        System.out.println("项目关联表单控件值map：" + xmMap);

        //转换成数组集合
        List xmList = new ArrayList();
        xmList.add(xmMap);
        String xmListString = JSON.toJSONString(xmList);
        System.out.println("项目关联表单控件值list文本json：" + xmListString);

        //参与人ID集合
        List list = new ArrayList();
        list.add("16583692962961532");
        list.add("16163038167819429");

        //执行人ID集合
        List list1 = new ArrayList();
        list1.add("16583692962961532");

        //任务时间集合（时间戳区间）
        List listTime = new ArrayList();
        listTime.add("1663664888000");
        listTime.add("1664528888000");

        Map map = new HashMap();
        //项目编码
        map.put("textField_l88d67g3", "111222333");
        //项目名称（关联表单组件）
        map.put("associationFormField_l82r3cm1", xmListString);
        //任务编码
        map.put("textField_l88d67g2","123123123");
        //任务名称
        map.put("textField_l82r3cm2","任务名称111");
        //参与者ID列表
        map.put("employeeField_l82r3cm5",list);
        //执行者ID列表
        map.put("employeeField_l82r3cm4",list1);
        //任务时间（时间戳区间）
        map.put("cascadeDateField_l82r3cm7",listTime);
        //创建人员ID（钉钉ID）
        map.put("employeeField_l82r3cm3", "15973727592422668");
        //创建时间
        map.put("dateField_l82r3cm8", time1);
        String mapJson = JSON.toJSONString(map);

        com.aliyun.dingtalkyida_1_0.Client client = createClient();
        StartInstanceHeaders startInstanceHeaders = new StartInstanceHeaders();
        startInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
        StartInstanceRequest startInstanceRequest = new StartInstanceRequest()
                .setAppType("APP_NOQGHDKUDXD7VDWZUC6I")
                .setSystemToken("WP966ZB1A4S3UPKK874E098BVPXN2EHYMP28LZE")
                .setUserId("15973727592422668")
                .setLanguage("zh_CN")
                .setFormUuid("FORM-2J6666D178X3VAUFCFHXRCEX9QF825S63R28LI")
                .setFormDataJson(mapJson);
//                //流程编码
//                .setProcessCode("TPROC--EF6Y4xxx")
//                //发起人所在部门ID
//                .setDepartmentId("18295");
        try {
            client.startInstanceWithOptions(startInstanceRequest, startInstanceHeaders, new RuntimeOptions());
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
    }

    //闻政tbOrganizationId
    public static String tbOrganizationId = "61dd45c6a1b6504502b29f8c";

    @Test
    public void getXiangmu(){

        //1、将TB的userid放在数组中
//        List list = new ArrayList();
//        list.add(userId);
//        System.out.println("list：" + list);
        //2、将TB接口指定传入的body请求体封装成集合
        Map map = new HashMap();
//        map.put("orgId",tbOrganizationId);
//        map.put("userIds",list);
        map.put("projectId","643d4596344ff5c7683574d2");
        String userBody = JSON.toJSONString(map);
        System.out.println("userBody：" + userBody);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/project/info?orgId=" + tbOrganizationId)
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                //TB应用授权码
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                //租户类型，默认为 organization
                .addHeader("X-Tenant-Type", "organization")
                .build();

        String body = null;
        try {
            Response response = client.newCall(request).execute();
            body = response.body().string();
            JSONObject jsonObject = JSON.parseObject(body);
            System.out.println("返回体body：" + jsonObject);
        }catch (IOException e){
            e.printStackTrace();
        }
    }


    //更新TB项目概览自定义字段
    @Test
    public void updateCustomfieldId(){

        String xmid = "643d4596344ff5c7683574d2";

//        String xmid = "643fa29f4da203eb51690128";
//        String tbuserId = "5f3a250040ce230ba377bf3c";
//        String title = "是";
//        String customfieldId = "643d4597a509e6c7511dc781";


        //待更新字段内容
        List list = new ArrayList();
        Map map = new HashMap();
        map.put("id","");
        map.put("title","是");
        list.add(map);

        Map mapAll = new HashMap();
        //项目概览字段ID
        mapAll.put("customfieldName","实施牵头主体");
        mapAll.put("value",list);

        String bodyJsonStr = JSON.toJSONString(mapAll);
        System.out.println("封装待更新概览字段后，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                //路径参数传入：项目ID
                .url("https://open.teambition.com/api/v3/project/"+ xmid +"/status/customfield/create")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                //操作人员ID（TB人员的ID）
                .addHeader("x-operator-id", "5f3a250040ce230ba377bf3c")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新项目概览接口返回的状态码（200成功，400异常）：" + code);
    }


    //调用TB搜索企业成员接口获取TB人员ID
    @Test
    public void getUserIdForTB(){
        String userName = "郑晓峰";

        //调用TB搜索企业成员接口获取TB人员ID
        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/org/member/search?orgId="+ tbOrganizationId +"&query=" + userName)
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        String body = null;
        String userId = null;
        try {
            Response response = client.newCall(request).execute();
            body = response.body().string();
            JSONObject jsonObject = JSON.parseObject(body);
            System.out.println("返回体body：" + jsonObject);
            //TODO 【需要注意：可能存在重名的情况，目前只获取返回结果的第一个人员】
            JSONArray result = jsonObject.getJSONArray("result");
            userId = result.getJSONObject(0).getString("userId");
            System.out.println("接口返回的TB人员userId：" + userId);
        }catch (IOException e){
            e.printStackTrace();
        }
    }

    //TEST
    @Test
    public void Test(){
        /*传参示例*/
//        【人员userId】["011033176057775267"]
//        【项目成员List】["011467460262746600","0806565327692090"]
//        【业务归属】销服
//        【区域】北区
//        【实施主体】销服-东区
//        【合同归属】上海闻政
//        【销售类型】直销
//        【合同编号】2023-WZ-WZX-043
//        【业务类型】咨询
//        【项目类型】实施型项目
//        【项目名称】2023上海城投老港基地公交轨交
//        【客户名称】上海城投老港基地管理有限公司
//        【客户等级】3星
//        【产品线】公交轨交
//        【所属省】上海市
//        【所属市区】上海市
//        【所属区县】浦东新区
//        【销售人员列表】["011033176057775267"]
//        【售前人员列表】["011467460262746600"]
//        【合同金额】123
//        【合同外金额】
//        【外部借调费用】111
//        【是否为代理项目】是
//        【渠道代理名称】【测试】渠道（代理）名称
//        【运维模式】
//        【运维月数】
//        【是否新业态】是

        String userId = "[\"011033176057775267\"]";
        String xiangmuchengyuanList = "[\"011467460262746600\",\"0806565327692090\"]";

        //操作人员ID（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
        String userStr = userId.replace("\"", "").
                replaceAll("\\[", "").
                replaceAll("\\]", "");
        System.out.println("操作人员ID（钉钉ID）：" + userStr);

        //项目成员List（钉钉ID）
        //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
        String chengyuanListStr = xiangmuchengyuanList.
                replaceAll("\\[", "").
                replaceAll("\\]", "");
        System.out.println("项目成员List（钉钉ID）：" + chengyuanListStr);
    }

    @Test
    public void Zongkanban(){
        String bodyJsonStr = "{\"executorId\":\"61dd45cd5489a8ab5c766e6b\",\"dueDate\":\"2023-06-30 00:00:00\",\"involveMembers\":[\"61dd45cb9efdfedea599dbe1\"],\"projectId\":\"63c64671432c0b7bbba01c48\",\"customfields\":[{\"customfieldName\":\"产品分类\",\"value\":[{\"id\":\"\",\"title\":\"财政绩效咨询服务\"}]},{\"customfieldName\":\"是否新业态\",\"value\":[{\"id\":\"\",\"title\":\"否\"}]},{\"customfieldName\":\"产品线\",\"value\":[{\"id\":\"\",\"title\":\"传统咨询\"}]},{\"customfieldName\":\"业务归属\",\"value\":[{\"id\":\"\",\"title\":\"销服\"}]},{\"customfieldName\":\"区域\",\"value\":[{\"id\":\"\",\"title\":\"东区\"}]},{\"customfieldName\":\"实施牵头主体\",\"value\":[{\"id\":\"\",\"title\":\"销服-东区\"}]},{\"customfieldName\":\"合同归属\",\"value\":[{\"id\":\"\",\"title\":\"上海闻政\"}]},{\"customfieldName\":\"销售类型\",\"value\":[{\"id\":\"\",\"title\":\"直销\"}]},{\"customfieldName\":\"合同编号\",\"value\":[{\"id\":\"\",\"title\":\"2023-WZ-WZX-035\"}]},{\"customfieldName\":\"项目类型\",\"value\":[{\"id\":\"\",\"title\":\"完整型咨询项目\"}]},{\"customfieldName\":\"项目名称\",\"value\":[{\"id\":\"\",\"title\":\"上海出入境边防检查总站单位整体支出绩效评价项目\"}]},{\"customfieldName\":\"项目等级\",\"value\":[{\"id\":\"\",\"title\":\"C+\"}]},{\"customfieldName\":\"客户名称\",\"value\":[{\"id\":\"\",\"title\":\"上海出入境边防检查总站\"}]},{\"customfieldName\":\"客户类型\",\"value\":[{\"id\":\"\",\"title\":\"政府部门\"}]},{\"customfieldName\":\"客户等级\",\"value\":[{\"id\":\"\",\"title\":\"1星\"}]},{\"customfieldName\":\"所属省\",\"value\":[{\"id\":\"\",\"title\":\"上海市\"}]},{\"customfieldName\":\"所属市区\",\"value\":[{\"id\":\"\",\"title\":\"上海市\"}]},{\"customfieldName\":\"所属区县\",\"value\":[{\"id\":\"\",\"title\":\"浦东新区\"}]},{\"customfieldName\":\"是否为代理项目\",\"value\":[{\"id\":\"\",\"title\":\"否\"}]},{\"customfieldName\":\"渠道（代理）名称\",\"value\":[{\"id\":\"\",\"title\":\"\"}]},{\"customfieldName\":\"销售人员\",\"value\":[{\"id\":\"\",\"title\":\"罗列 \"}]},{\"customfieldName\":\"运维负责人\",\"value\":[{\"id\":\"\",\"title\":\"\"}]},{\"customfieldName\":\"运维月数\",\"value\":[{\"id\":\"\",\"title\":\"\"}]},{\"customfieldName\":\"合同金额 （元）\",\"value\":[{\"id\":\"\",\"title\":\"85000\"}]},{\"customfieldName\":\"项目经理\",\"value\":[{\"id\":\"\",\"title\":\"彭泽\"}]},{\"customfieldName\":\"项目成员\",\"value\":[{\"id\":\"\",\"title\":\"闫文婷 \"}]}],\"content\":\"上海出入境边防检查总站单位整体支出绩效评价项目\",\"startDate\":\"2023-05-06 00:00:00\"}";

//        Map map = new HashMap();
//        //项目id
//        map.put("projectId",xmid);
//        //任务标题（也就是项目名称）
//        map.put("content",xiangmumingcheng);
//        //执行者id（项目经理的id）
//        map.put("executorId",zhixingzheid);
//        //参与者id列表
//        map.put("involveMembers",canyuzheidList);
//        //开始时间
//        map.put("startDate",startDate);
//        //结束时间
//        map.put("dueDate",stopDate);
//        //自定义字段列表
//        map.put("customfields",zidingyiziduan);
//
//        String bodyJsonStr = JSON.toJSONString(map);
//        System.out.println("封装创建总看板子任务的参数，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                //路径
                .url("https://open.teambition.com/api/v3/task/create")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                //企业ID
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                //操作人员ID（TB人员的ID）【61c43a10698acdc15e217186为目前的项目拥有者（管理员id）】
                .addHeader("x-operator-id", "61c43a10698acdc15e217186")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("创建总看板的子任务接口返回的状态码（200成功，400异常）：" + code);
    }


    //查询项目信息
    @Test
    public void getXiangmuBoolean(){

        String xmmc = "2023年济南市中心城区城市污水处理设施运行年度评估项目";

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/query?name=" + xmmc)
                .method("GET", null)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        Boolean flag = false;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            //是否放入回收站（false没放入回收站；true已放入回收站）
            if (result.isEmpty()){
                flag = false;//为false将标识TB不存在该项目
            }else {
                Boolean isArchived = result.getJSONObject(0).getBoolean("isArchived");
                if (isArchived == true){
                    System.out.println("该项目已放入回收站！将视为不存在该项目！");
                    flag = false;
                }else {
                    flag = true;//为true将标识TB存在该项目
                }
            }
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("查询项目接口返回的状态码（200成功，400异常）：" + code);
        System.out.println("TB项目是否已存在flag为（true存在，false不存在）：" + flag);
    }

    //查询任务信息
    @Test
    public void getRenwuId(){

        /*
         * 总看板项目ID
         *
         * 交付总看板（软件类）：63c4ea646ff268bcab3f82b3
         * 交付总看板（咨询）：63c64671432c0b7bbba01c48
         * 交付总看板（运维）：63c64924df32b699b98cf049
         *
         * */

        String zongkanbanID = "63c64671432c0b7bbba01c48";
        String renwumingcheng = "2023年济南市中心城区城市污水处理设施运行年度评估项目";

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/" + zongkanbanID + "/task/query?q=text ~ " + renwumingcheng)
                .method("GET", null)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        String renwuID = null;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            renwuID = result.getJSONObject(0).getString("id");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("查询任务信息接口返回的状态码（200成功，400异常）：" + code);
        System.out.println("任务ID：" + renwuID);
    }

    //更新任务自定义字段
    @Test
    public void updateRenwu(){

//        //拥有者id
//        String yongyouzheid = "61c43a10698acdc15e217186";
//        //任务id
//        String renwuid = "645a067dcec1a416291fdfe2";
//        //待更新字段内容
//        String title = "闫文婷";
//        //待更新字段名称
//        String customfieldName = "项目成员";

        String yongyouzheid = "61dd45cb346f23961bc3312e";
        String renwuid = "64673350e618b357237d72d9";
        String title = "25000";
        String customfieldName = "开票金额 （元）";

        List list = new ArrayList();
        Map map = new HashMap();
        map.put("id","");
        //待更新字段内容
        map.put("title",title);
        list.add(map);

        Map mapAll = new HashMap();
        //总看板项目概览字段ID
        mapAll.put("customfieldName",customfieldName);
        mapAll.put("value",list);

        String bodyJsonStr = JSON.toJSONString(mapAll);
        System.out.println("封装待更新任务概览字段后，转换成String：" + bodyJsonStr);

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, bodyJsonStr);
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/task/"+renwuid+"/customfield/update")
                .method("POST", body)
                .addHeader("x-operator-id", yongyouzheid)
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .addHeader("Content-Type", "application/json")
                .build();

        int code = 0;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
//            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("更新任务结束时间接口返回的状态码（200成功，400异常）：" + code);
    }

    @Test
    public void xxx(){
        String QUERY = "{\"chanpinxian\":\"传统咨询\"," +
                "\"shifouweidailixiangmu\":\"否\"," +
                "\"xiangmuchengyuanList\":\"[\\\"0655216340938287\\\",\\\"1720564730786469\\\",\\\"173506083326385327\\\",\\\"0316016200950255\\\",\\\"1511030625781030\\\",\\\"063102593920237268\\\",\\\"091639314021541376\\\",\\\"141965154526182392\\\",\\\"170023480521297067\\\",\\\"32533357371068557\\\",\\\"014053100236551261\\\",\\\"214737235024071374\\\"]\"," +
                "\"hetongwaijine\":\"\"," +
                "\"suoshuquxian\":\"\"," +
                "\"yewuguishu\":\"销服\"," +
                "\"shishizhuti\":\"销服-北区\"," +
                "\"yewuleixing\":\"咨询\"," +
                "\"yunweimoshi\":\"\"," +
                "\"yunweiyueshu\":\"\"," +
                "\"xiangmujingli\":\"[\\\"170023480521297067\\\"]\"," +
                "\"xiaoshourenyuanList\":\"[\\\"146318090323126823\\\"]\"," +
                "\"qudaodailimingcheng\":\"\"," +
                "\"xiangmumingcheng\":\"2023年济南市中心城区城市污水处理设施运行年度评估项目\"," +
                "\"suoshusheng\":\"山东省\"," +
                "\"wanchengriqi\":\"1677513600000\"," +
                "\"hetongjine\":\"415000\"," +
                "\"shouqianrenyuanList\":\"[\\\"170023480521297067\\\"]\"," +
                "\"shifouxinyetai\":\"否\"," +
                "\"kehudengji\":\"2星\"," +
                "\"userId\":\"[\\\"3036066328940020\\\"]\"," +
                "\"xiangmudengji\":\"A\"," +
                "\"suoshushiqu\":\"济南市\"," +
                "\"kehuleixing\":\"政府部门\"," +
                "\"chanpinfenlei\":\"财政绩效咨询服务\"," +
                "\"quyu\":\"北区\"," +
                "\"hetongbianhao\":\"2023-WZ-WZX-017\"," +
                "\"xiangmuleixing\":\"完整型咨询项目\"," +
                "\"hetongguishu\":\"上海闻政\"," +
                "\"kehumingcheng\":\"济南市城乡水务局\"," +
                "\"waibujiediaofeiyong\":\"0\"," +
                "\"startDate\":\"1675180800000\"," +
                "\"stopDate\":\"1677513600000\"," +
                "\"xiaoshouleixing\":\"直销\"}";

        JSONObject jsonObject = JSON.parseObject(QUERY);
        System.out.println("jsonObject:" + jsonObject);
    }

    //获取项目角色id
    @Test
    public void getJuese(){
        String xmid = "640a921cbf74c954f908268f";

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://open.teambition.com/api/v3/project/" + xmid + "/role")
                .method("GET", null)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer " + accessTokenService.getAppToken())
                .addHeader("X-Tenant-Id", tbOrganizationId)
                .addHeader("X-Tenant-Type", "organization")
                .build();

        int code = 0;
        String jueseID = null;
        try {
            Response response = client.newCall(request).execute();
            String bodyStr = response.body().string();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            System.out.println("返回体body：" + jsonObject);
            code = jsonObject.getInteger("code");

            JSONArray result = jsonObject.getJSONArray("result");
            for (int i = 0; i < result.size(); i++) {
                String name = result.getJSONObject(i).getString("name");
                String id = result.getJSONObject(i).getString("id");
                if (name.equals("项目经理")){
                    jueseID = id;
                }
            }
        }catch (IOException e){
            e.printStackTrace();
        }
        System.out.println("获取项目角色列表（主要用于获取项目经理的角色id）接口返回的状态码（200成功，400异常）：" + code);
    }

    /*钉钉-TB接口*/
    public static com.aliyun.dingtalkproject_1_0.Client createClient1() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkproject_1_0.Client(config);
    }
    /*钉钉-TB接口*/

    @Test
    public void test111(){
        /*一、根据模板创建TB项目*/
//        log.info("开始执行根据模板创建TB项目...");
        JSONObject jsonObject = null;
        try {
            com.aliyun.dingtalkproject_1_0.Client client = createClient1();
            com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders createProjectByTemplateHeaders = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateHeaders();
            createProjectByTemplateHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest createProjectByTemplateRequest = new com.aliyun.dingtalkproject_1_0.models.CreateProjectByTemplateRequest()
                    //项目名称
                    .setName("test1111111111")
                    //模板ID
                    .setTemplateId("63fd67eaba9b960018ff8b12");

            //操作人员userId（目前统一默认【郑晓峰61dd45cc5eeb5025ebd13ff1】为项目创建人）
            CreateProjectByTemplateResponse projectByTemplateWithOptions = client.createProjectByTemplateWithOptions("014420484336462990", createProjectByTemplateRequest, createProjectByTemplateHeaders, new RuntimeOptions());
            String s = JSON.toJSONString(projectByTemplateWithOptions.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("【创建项目】接口object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }
        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }
        }
        System.out.println("【创建项目】接口object对象：" + jsonObject);
        String xiangmuId = jsonObject.getJSONObject("result").getString("id");
        System.out.println("【创建项目】接口object对象返回的【项目ID】：" + xiangmuId);
    }
}
